package UML::MetaModel::Foundation::Core::Artifact;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Classifier);

sub __model_name { 'Foundation::Core::Artifact' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaArtifact { 1 }

sub isaFoundation__Core__Artifact { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Artifact')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Artifact': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize;

# AssociationEnd 0x86a11ac name = implementationLocation, type = Foundation::Core::Component multiplicity = *
$self->{'implementationLocation'} = undef unless exists $self->{'implementationLocation'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize_associations;

# AssociationEnd 0x86a11ac name = implementationLocation, type = Foundation::Core::Component multiplicity = *

	      if ( defined $self->{'implementationLocation'} && @{$self->{'implementationLocation'}}) {
		my $x = $self->{'implementationLocation'};
		$self->{'implementationLocation'} = [ ];
		$self->add_implementationLocation(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86a11ac name = implementationLocation, type = Foundation::Core::Component multiplicity = *

	      sub implementationLocation {
		my ($self) = @_;
		
		my $x = $self->{'implementationLocation'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_implementationLocation {
		my ($self, @new) = @_;
		
		$self->clear_implementationLocation;
		$self->add_implementationLocation(@new);
	      }
	      sub add_implementationLocation {
		my ($self, @new) = @_;
		
		my $x = $self->{'implementationLocation'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Component')
    ->__typecheck($new, 'implementationLocation');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8737c9c name = implementation, type = Foundation::Core::Artifact, multiplicity = *

	  $old->remove_implementation($self) if $old;
	  $new->add_implementation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_implementationLocation {
		my ($self, @new) = @_;

		my $x = $self->{'implementationLocation'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Component')
    ->__typecheck($old, 'implementationLocation');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8737c9c name = implementation, type = Foundation::Core::Artifact, multiplicity = *

	  $old->remove_implementation($self) if $old;
	  $new->add_implementation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_implementationLocation {
		my ($self) = @_;

		my $x = $self->{'implementationLocation'} ||= [ ];
		my $new; # Place holder

		$self->{'implementationLocation'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8737c9c name = implementation, type = Foundation::Core::Artifact, multiplicity = *

	  $old->remove_implementation($self) if $old;
	  $new->add_implementation($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

