package UML::MetaModel::Foundation::Core::Association;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Relationship UML::MetaModel::Foundation::Core::GeneralizableElement);

sub __model_name { 'Foundation::Core::Association' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaAssociation { 1 }

sub isaFoundation__Core__Association { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Association')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Association': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize;
  $self->UML::MetaModel::Foundation::Core::GeneralizableElement::__initialize;

# AssociationEnd 0x872d944 name = connection, type = Foundation::Core::AssociationEnd multiplicity = 2..*
$self->{'connection'} = undef unless exists $self->{'connection'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize_associations;
  $self->UML::MetaModel::Foundation::Core::GeneralizableElement::__initialize_associations;

# AssociationEnd 0x872d944 name = connection, type = Foundation::Core::AssociationEnd multiplicity = 2..*

	      if ( defined $self->{'connection'} && @{$self->{'connection'}}) {
		my $x = $self->{'connection'};
		$self->{'connection'} = [ ];
		$self->add_connection(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x872d944 name = connection, type = Foundation::Core::AssociationEnd multiplicity = 2..*

	      sub connection {
		my ($self) = @_;
		
		my $x = $self->{'connection'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_connection {
		my ($self, @new) = @_;
		
		$self->clear_connection;
		$self->add_connection(@new);
	      }
	      sub add_connection {
		my ($self, @new) = @_;
		
		my $x = $self->{'connection'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($new, 'connection');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x868ca08 name = connection_, type = Foundation::Core::Association, multiplicity = 1

	  $old->set_connection_($self) if $old;
	  $new->set_connection_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_connection {
		my ($self, @new) = @_;

		my $x = $self->{'connection'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($old, 'connection');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x868ca08 name = connection_, type = Foundation::Core::Association, multiplicity = 1

	  $old->set_connection_($self) if $old;
	  $new->set_connection_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_connection {
		my ($self) = @_;

		my $x = $self->{'connection'} ||= [ ];
		my $new; # Place holder

		$self->{'connection'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x868ca08 name = connection_, type = Foundation::Core::Association, multiplicity = 1

	  $old->set_connection_($self) if $old;
	  $new->set_connection_($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

