package UML::MetaModel::Foundation::Core::AssociationEnd;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::AssociationEnd' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaAssociationEnd { 1 }

sub isaFoundation__Core__AssociationEnd { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::AssociationEnd')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::AssociationEnd': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x868ca08 name = connection_, type = Foundation::Core::Association multiplicity = 1
$self->{'connection_'} = undef unless exists $self->{'connection_'};
# AssociationEnd 0x870d388 name = participant, type = Foundation::Core::Classifier multiplicity = 1
$self->{'participant'} = undef unless exists $self->{'participant'};
# AssociationEnd 0x8737228 name = specification, type = Foundation::Core::Classifier multiplicity = *
$self->{'specification'} = undef unless exists $self->{'specification'};
# AssociationEnd 0x87371ec name = qualifier, type = Foundation::Core::Attribute multiplicity = *
$self->{'qualifier'} = undef unless exists $self->{'qualifier'};
# Attribute 0x86e2e58 name = isNavigable, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isNavigable'} ) {
	    my $x = $self->{'isNavigable'};
	    $self->{'isNavigable'} = undef;
	    $self->set_isNavigable($x);
	  } else {
	    ;
	  }
	
# Attribute 0x86e2f6c name = ordering, type = Foundation::Data_Types::OrderingKind, multiplicity = 1

	  if ( exists $self->{'ordering'} ) {
	    my $x = $self->{'ordering'};
	    $self->{'ordering'} = undef;
	    $self->set_ordering($x);
	  } else {
	    ;
	  }
	
# Attribute 0x87545e4 name = aggregation, type = Foundation::Data_Types::AggregationKind, multiplicity = 1

	  if ( exists $self->{'aggregation'} ) {
	    my $x = $self->{'aggregation'};
	    $self->{'aggregation'} = undef;
	    $self->set_aggregation($x);
	  } else {
	    ;
	  }
	
# Attribute 0x87546bc name = targetScope, type = Foundation::Data_Types::ScopeKind, multiplicity = 1

	  if ( exists $self->{'targetScope'} ) {
	    my $x = $self->{'targetScope'};
	    $self->{'targetScope'} = undef;
	    $self->set_targetScope($x);
	  } else {
	    ;
	  }
	
# Attribute 0x87547a0 name = multiplicity, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  if ( exists $self->{'multiplicity'} ) {
	    my $x = $self->{'multiplicity'};
	    $self->{'multiplicity'} = undef;
	    $self->set_multiplicity($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8754884 name = changability, type = Foundation::Data_Types::ChangeableKind, multiplicity = 1

	  if ( exists $self->{'changability'} ) {
	    my $x = $self->{'changability'};
	    $self->{'changability'} = undef;
	    $self->set_changability($x);
	  } else {
	    ;
	  }
	
# Attribute 0x87549bc name = visibility, type = Foundation::Data_Types::VisibilityKind, multiplicity = 1

	  if ( exists $self->{'visibility'} ) {
	    my $x = $self->{'visibility'};
	    $self->{'visibility'} = undef;
	    $self->set_visibility($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x868ca08 name = connection_, type = Foundation::Core::Association multiplicity = 1

	      if ( defined $self->{'connection_'} ) {
		my $x = $self->{'connection_'};
		$self->{'connection_'} = undef;
		$self->set_connection_($x);
	      }
	    
# AssociationEnd 0x870d388 name = participant, type = Foundation::Core::Classifier multiplicity = 1

	      if ( defined $self->{'participant'} ) {
		my $x = $self->{'participant'};
		$self->{'participant'} = undef;
		$self->set_participant($x);
	      }
	    
# AssociationEnd 0x8737228 name = specification, type = Foundation::Core::Classifier multiplicity = *

	      if ( defined $self->{'specification'} && @{$self->{'specification'}}) {
		my $x = $self->{'specification'};
		$self->{'specification'} = [ ];
		$self->add_specification(@$x);
	      }
	    
# AssociationEnd 0x87371ec name = qualifier, type = Foundation::Core::Attribute multiplicity = *

	      if ( defined $self->{'qualifier'} && @{$self->{'qualifier'}}) {
		my $x = $self->{'qualifier'};
		$self->{'qualifier'} = [ ];
		$self->add_qualifier(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x868ca08 name = connection_, type = Foundation::Core::Association multiplicity = 1

	      sub connection_ {
		my ($self) = @_;
		
		$self->{'connection_'};
	      }
	      sub set_connection_ {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'connection_'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Association')
    ->__typecheck($new, 'connection_');
  ;
		  $self->{'connection_'} = $new;        # Recursion lock
		  # AssociationEnd 0x872d944 name = connection, type = Foundation::Core::AssociationEnd, multiplicity = 2..*

	  $old->remove_connection($self) if $old;
	  $new->add_connection($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x870d388 name = participant, type = Foundation::Core::Classifier multiplicity = 1

	      sub participant {
		my ($self) = @_;
		
		$self->{'participant'};
	      }
	      sub set_participant {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'participant'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($new, 'participant');
  ;
		  $self->{'participant'} = $new;        # Recursion lock
		  # AssociationEnd 0x872daf4 name = association, type = Foundation::Core::AssociationEnd, multiplicity = *

	  $old->remove_association($self) if $old;
	  $new->add_association($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x8737228 name = specification, type = Foundation::Core::Classifier multiplicity = *

	      sub specification {
		my ($self) = @_;
		
		my $x = $self->{'specification'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_specification {
		my ($self, @new) = @_;
		
		$self->clear_specification;
		$self->add_specification(@new);
	      }
	      sub add_specification {
		my ($self, @new) = @_;
		
		my $x = $self->{'specification'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($new, 'specification');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ba364 name = specifiedEnd, type = Foundation::Core::AssociationEnd, multiplicity = *

	  $old->remove_specifiedEnd($self) if $old;
	  $new->add_specifiedEnd($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_specification {
		my ($self, @new) = @_;

		my $x = $self->{'specification'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($old, 'specification');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ba364 name = specifiedEnd, type = Foundation::Core::AssociationEnd, multiplicity = *

	  $old->remove_specifiedEnd($self) if $old;
	  $new->add_specifiedEnd($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_specification {
		my ($self) = @_;

		my $x = $self->{'specification'} ||= [ ];
		my $new; # Place holder

		$self->{'specification'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ba364 name = specifiedEnd, type = Foundation::Core::AssociationEnd, multiplicity = *

	  $old->remove_specifiedEnd($self) if $old;
	  $new->add_specifiedEnd($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x87371ec name = qualifier, type = Foundation::Core::Attribute multiplicity = *

	      sub qualifier {
		my ($self) = @_;
		
		my $x = $self->{'qualifier'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_qualifier {
		my ($self, @new) = @_;
		
		$self->clear_qualifier;
		$self->add_qualifier(@new);
	      }
	      sub add_qualifier {
		my ($self, @new) = @_;
		
		my $x = $self->{'qualifier'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Attribute')
    ->__typecheck($new, 'qualifier');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ba5b0 name = associationEnd, type = Foundation::Core::AssociationEnd, multiplicity = 0..1

	  $old->set_associationEnd($self) if $old;
	  $new->set_associationEnd($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_qualifier {
		my ($self, @new) = @_;

		my $x = $self->{'qualifier'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Attribute')
    ->__typecheck($old, 'qualifier');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ba5b0 name = associationEnd, type = Foundation::Core::AssociationEnd, multiplicity = 0..1

	  $old->set_associationEnd($self) if $old;
	  $new->set_associationEnd($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_qualifier {
		my ($self) = @_;

		my $x = $self->{'qualifier'} ||= [ ];
		my $new; # Place holder

		$self->{'qualifier'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ba5b0 name = associationEnd, type = Foundation::Core::AssociationEnd, multiplicity = 0..1

	  $old->set_associationEnd($self) if $old;
	  $new->set_associationEnd($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x86e2e58 name = isNavigable, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isNavigable {
	    my ($self) = @_;

	    $self->{'isNavigable'};
	  }
	  sub set_isNavigable {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isNavigable');
  ;

	    $self->{'isNavigable'} = $new;

	    $self;
	  }
	
# Attribute 0x86e2f6c name = ordering, type = Foundation::Data_Types::OrderingKind, multiplicity = 1

	  sub ordering {
	    my ($self) = @_;

	    $self->{'ordering'};
	  }
	  sub set_ordering {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::OrderingKind')
    ->__typecheck($new, 'ordering');
  ;

	    $self->{'ordering'} = $new;

	    $self;
	  }
	
# Attribute 0x87545e4 name = aggregation, type = Foundation::Data_Types::AggregationKind, multiplicity = 1

	  sub aggregation {
	    my ($self) = @_;

	    $self->{'aggregation'};
	  }
	  sub set_aggregation {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::AggregationKind')
    ->__typecheck($new, 'aggregation');
  ;

	    $self->{'aggregation'} = $new;

	    $self;
	  }
	
# Attribute 0x87546bc name = targetScope, type = Foundation::Data_Types::ScopeKind, multiplicity = 1

	  sub targetScope {
	    my ($self) = @_;

	    $self->{'targetScope'};
	  }
	  sub set_targetScope {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ScopeKind')
    ->__typecheck($new, 'targetScope');
  ;

	    $self->{'targetScope'} = $new;

	    $self;
	  }
	
# Attribute 0x87547a0 name = multiplicity, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  sub multiplicity {
	    my ($self) = @_;

	    $self->{'multiplicity'};
	  }
	  sub set_multiplicity {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Multiplicity')
    ->__typecheck($new, 'multiplicity');
  ;

	    $self->{'multiplicity'} = $new;

	    $self;
	  }
	
# Attribute 0x8754884 name = changability, type = Foundation::Data_Types::ChangeableKind, multiplicity = 1

	  sub changability {
	    my ($self) = @_;

	    $self->{'changability'};
	  }
	  sub set_changability {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ChangeableKind')
    ->__typecheck($new, 'changability');
  ;

	    $self->{'changability'} = $new;

	    $self;
	  }
	
# Attribute 0x87549bc name = visibility, type = Foundation::Data_Types::VisibilityKind, multiplicity = 1

	  sub visibility {
	    my ($self) = @_;

	    $self->{'visibility'};
	  }
	  sub set_visibility {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::VisibilityKind')
    ->__typecheck($new, 'visibility');
  ;

	    $self->{'visibility'} = $new;

	    $self;
	  }
	


1;

