package UML::MetaModel::Foundation::Core::Attribute;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::StructuralFeature);

sub __model_name { 'Foundation::Core::Attribute' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaAttribute { 1 }

sub isaFoundation__Core__Attribute { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Attribute')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Attribute': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::StructuralFeature::__initialize;

# AssociationEnd 0x86ba5b0 name = associationEnd, type = Foundation::Core::AssociationEnd multiplicity = 0..1
$self->{'associationEnd'} = undef unless exists $self->{'associationEnd'};
# Attribute 0x86fab74 name = initialValue, type = Foundation::Data_Types::Expression, multiplicity = 1

	  if ( exists $self->{'initialValue'} ) {
	    my $x = $self->{'initialValue'};
	    $self->{'initialValue'} = undef;
	    $self->set_initialValue($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::StructuralFeature::__initialize_associations;

# AssociationEnd 0x86ba5b0 name = associationEnd, type = Foundation::Core::AssociationEnd multiplicity = 0..1

	      if ( defined $self->{'associationEnd'} ) {
		my $x = $self->{'associationEnd'};
		$self->{'associationEnd'} = undef;
		$self->set_associationEnd($x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ba5b0 name = associationEnd, type = Foundation::Core::AssociationEnd multiplicity = 0..1

	      sub associationEnd {
		my ($self) = @_;
		
		$self->{'associationEnd'};
	      }
	      sub set_associationEnd {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'associationEnd'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::AssociationEnd')
    ->__typecheck($new, 'associationEnd');
  ;
		  $self->{'associationEnd'} = $new;        # Recursion lock
		  # AssociationEnd 0x87371ec name = qualifier, type = Foundation::Core::Attribute, multiplicity = *

	  $old->remove_qualifier($self) if $old;
	  $new->add_qualifier($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x86fab74 name = initialValue, type = Foundation::Data_Types::Expression, multiplicity = 1

	  sub initialValue {
	    my ($self) = @_;

	    $self->{'initialValue'};
	  }
	  sub set_initialValue {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Expression')
    ->__typecheck($new, 'initialValue');
  ;

	    $self->{'initialValue'} = $new;

	    $self;
	  }
	


1;

