package UML::MetaModel::Foundation::Core::Comment;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::Comment' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaComment { 1 }

sub isaFoundation__Core__Comment { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Comment')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Comment': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x86ca698 name = annotatedElement, type = Foundation::Core::ModelElement multiplicity = *
$self->{'annotatedElement'} = undef unless exists $self->{'annotatedElement'};
# Attribute 0x86d4638 name = name, type = Foundation::Data_Types::String, multiplicity = 1

	  if ( exists $self->{'name'} ) {
	    my $x = $self->{'name'};
	    $self->{'name'} = undef;
	    $self->set_name($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x86ca698 name = annotatedElement, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'annotatedElement'} && @{$self->{'annotatedElement'}}) {
		my $x = $self->{'annotatedElement'};
		$self->{'annotatedElement'} = [ ];
		$self->add_annotatedElement(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ca698 name = annotatedElement, type = Foundation::Core::ModelElement multiplicity = *

	      sub annotatedElement {
		my ($self) = @_;
		
		my $x = $self->{'annotatedElement'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_annotatedElement {
		my ($self, @new) = @_;
		
		$self->clear_annotatedElement;
		$self->add_annotatedElement(@new);
	      }
	      sub add_annotatedElement {
		my ($self, @new) = @_;
		
		my $x = $self->{'annotatedElement'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'annotatedElement');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86bb98c name = annotatedElement_, type = Foundation::Core::Comment, multiplicity = *

	  $old->remove_annotatedElement_($self) if $old;
	  $new->add_annotatedElement_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_annotatedElement {
		my ($self, @new) = @_;

		my $x = $self->{'annotatedElement'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'annotatedElement');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86bb98c name = annotatedElement_, type = Foundation::Core::Comment, multiplicity = *

	  $old->remove_annotatedElement_($self) if $old;
	  $new->add_annotatedElement_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_annotatedElement {
		my ($self) = @_;

		my $x = $self->{'annotatedElement'} ||= [ ];
		my $new; # Place holder

		$self->{'annotatedElement'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86bb98c name = annotatedElement_, type = Foundation::Core::Comment, multiplicity = *

	  $old->remove_annotatedElement_($self) if $old;
	  $new->add_annotatedElement_($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x86d4638 name = name, type = Foundation::Data_Types::String, multiplicity = 1

	  sub name {
	    my ($self) = @_;

	    $self->{'name'};
	  }
	  sub set_name {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::String')
    ->__typecheck($new, 'name');
  ;

	    $self->{'name'} = $new;

	    $self;
	  }
	


1;

