package UML::MetaModel::Foundation::Core::Component;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Classifier);

sub __model_name { 'Foundation::Core::Component' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaComponent { 1 }

sub isaFoundation__Core__Component { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Component')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Component': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize;

# AssociationEnd 0x875a6b8 name = deploymentLocation, type = Foundation::Core::Node multiplicity = *
$self->{'deploymentLocation'} = undef unless exists $self->{'deploymentLocation'};
# AssociationEnd 0x8737c9c name = implementation, type = Foundation::Core::Artifact multiplicity = *
$self->{'implementation'} = undef unless exists $self->{'implementation'};
# AssociationEnd 0x86c9f48 name = resident, type = Foundation::Core::ModelElement multiplicity = *
$self->{'resident'} = undef unless exists $self->{'resident'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize_associations;

# AssociationEnd 0x875a6b8 name = deploymentLocation, type = Foundation::Core::Node multiplicity = *

	      if ( defined $self->{'deploymentLocation'} && @{$self->{'deploymentLocation'}}) {
		my $x = $self->{'deploymentLocation'};
		$self->{'deploymentLocation'} = [ ];
		$self->add_deploymentLocation(@$x);
	      }
	    
# AssociationEnd 0x8737c9c name = implementation, type = Foundation::Core::Artifact multiplicity = *

	      if ( defined $self->{'implementation'} && @{$self->{'implementation'}}) {
		my $x = $self->{'implementation'};
		$self->{'implementation'} = [ ];
		$self->add_implementation(@$x);
	      }
	    
# AssociationEnd 0x86c9f48 name = resident, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'resident'} && @{$self->{'resident'}}) {
		my $x = $self->{'resident'};
		$self->{'resident'} = [ ];
		$self->add_resident(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x875a6b8 name = deploymentLocation, type = Foundation::Core::Node multiplicity = *

	      sub deploymentLocation {
		my ($self) = @_;
		
		my $x = $self->{'deploymentLocation'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_deploymentLocation {
		my ($self, @new) = @_;
		
		$self->clear_deploymentLocation;
		$self->add_deploymentLocation(@new);
	      }
	      sub add_deploymentLocation {
		my ($self, @new) = @_;
		
		my $x = $self->{'deploymentLocation'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Node')
    ->__typecheck($new, 'deploymentLocation');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8737aec name = deployedComponent, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_deployedComponent($self) if $old;
	  $new->add_deployedComponent($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_deploymentLocation {
		my ($self, @new) = @_;

		my $x = $self->{'deploymentLocation'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Node')
    ->__typecheck($old, 'deploymentLocation');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8737aec name = deployedComponent, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_deployedComponent($self) if $old;
	  $new->add_deployedComponent($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_deploymentLocation {
		my ($self) = @_;

		my $x = $self->{'deploymentLocation'} ||= [ ];
		my $new; # Place holder

		$self->{'deploymentLocation'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8737aec name = deployedComponent, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_deployedComponent($self) if $old;
	  $new->add_deployedComponent($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x8737c9c name = implementation, type = Foundation::Core::Artifact multiplicity = *

	      sub implementation {
		my ($self) = @_;
		
		my $x = $self->{'implementation'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_implementation {
		my ($self, @new) = @_;
		
		$self->clear_implementation;
		$self->add_implementation(@new);
	      }
	      sub add_implementation {
		my ($self, @new) = @_;
		
		my $x = $self->{'implementation'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Artifact')
    ->__typecheck($new, 'implementation');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86a11ac name = implementationLocation, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_implementationLocation($self) if $old;
	  $new->add_implementationLocation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_implementation {
		my ($self, @new) = @_;

		my $x = $self->{'implementation'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Artifact')
    ->__typecheck($old, 'implementation');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86a11ac name = implementationLocation, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_implementationLocation($self) if $old;
	  $new->add_implementationLocation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_implementation {
		my ($self) = @_;

		my $x = $self->{'implementation'} ||= [ ];
		my $new; # Place holder

		$self->{'implementation'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86a11ac name = implementationLocation, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_implementationLocation($self) if $old;
	  $new->add_implementationLocation($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86c9f48 name = resident, type = Foundation::Core::ModelElement multiplicity = *

	      sub resident {
		my ($self) = @_;
		
		my $x = $self->{'resident'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_resident {
		my ($self, @new) = @_;
		
		$self->clear_resident;
		$self->add_resident(@new);
	      }
	      sub add_resident {
		my ($self, @new) = @_;
		
		my $x = $self->{'resident'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'resident');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x87543e0 name = container, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_container($self) if $old;
	  $new->add_container($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_resident {
		my ($self, @new) = @_;

		my $x = $self->{'resident'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'resident');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x87543e0 name = container, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_container($self) if $old;
	  $new->add_container($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_resident {
		my ($self) = @_;

		my $x = $self->{'resident'} ||= [ ];
		my $new; # Place holder

		$self->{'resident'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x87543e0 name = container, type = Foundation::Core::Component, multiplicity = *

	  $old->remove_container($self) if $old;
	  $new->add_container($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

