package UML::MetaModel::Foundation::Core::Constraint;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::Constraint' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaConstraint { 1 }

sub isaFoundation__Core__Constraint { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Constraint')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Constraint': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x8717024 name = constrainedElement, type = Foundation::Core::ModelElement multiplicity = 0..1
$self->{'constrainedElement'} = undef unless exists $self->{'constrainedElement'};
# AssociationEnd 0x86bb9c8 name = constrainedStereotype, type = Foundation::Extension_Mechanisms::Stereotype multiplicity = 0..1
$self->{'constrainedStereotype'} = undef unless exists $self->{'constrainedStereotype'};
# Attribute 0x87630a8 name = body, type = Foundation::Data_Types::BooleanExpression, multiplicity = 1

	  if ( exists $self->{'body'} ) {
	    my $x = $self->{'body'};
	    $self->{'body'} = undef;
	    $self->set_body($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x8717024 name = constrainedElement, type = Foundation::Core::ModelElement multiplicity = 0..1

	      if ( defined $self->{'constrainedElement'} ) {
		my $x = $self->{'constrainedElement'};
		$self->{'constrainedElement'} = undef;
		$self->set_constrainedElement($x);
	      }
	    
# AssociationEnd 0x86bb9c8 name = constrainedStereotype, type = Foundation::Extension_Mechanisms::Stereotype multiplicity = 0..1

	      if ( defined $self->{'constrainedStereotype'} ) {
		my $x = $self->{'constrainedStereotype'};
		$self->{'constrainedStereotype'} = undef;
		$self->set_constrainedStereotype($x);
	      }
	    

  $self;
}

# AssociationEnd 0x8717024 name = constrainedElement, type = Foundation::Core::ModelElement multiplicity = 0..1

	      sub constrainedElement {
		my ($self) = @_;
		
		$self->{'constrainedElement'};
	      }
	      sub set_constrainedElement {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'constrainedElement'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'constrainedElement');
  ;
		  $self->{'constrainedElement'} = $new;        # Recursion lock
		  # AssociationEnd 0x870d9bc name = constraint, type = Foundation::Core::Constraint, multiplicity = *

	  $old->remove_constraint($self) if $old;
	  $new->add_constraint($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x86bb9c8 name = constrainedStereotype, type = Foundation::Extension_Mechanisms::Stereotype multiplicity = 0..1

	      sub constrainedStereotype {
		my ($self) = @_;
		
		$self->{'constrainedStereotype'};
	      }
	      sub set_constrainedStereotype {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'constrainedStereotype'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::Stereotype')
    ->__typecheck($new, 'constrainedStereotype');
  ;
		  $self->{'constrainedStereotype'} = $new;        # Recursion lock
		  # AssociationEnd 0x86ca758 name = stereotypeConstraint, type = Foundation::Core::Constraint, multiplicity = *

	  $old->remove_stereotypeConstraint($self) if $old;
	  $new->add_stereotypeConstraint($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x87630a8 name = body, type = Foundation::Data_Types::BooleanExpression, multiplicity = 1

	  sub body {
	    my ($self) = @_;

	    $self->{'body'};
	  }
	  sub set_body {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::BooleanExpression')
    ->__typecheck($new, 'body');
  ;

	    $self->{'body'} = $new;

	    $self;
	  }
	


1;

