package UML::MetaModel::Foundation::Core::Feature;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::Feature' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaFeature { 1 }

sub isaFoundation__Core__Feature { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Feature')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Feature': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x875aa94 name = owner, type = Foundation::Core::Classifier multiplicity = 0..1
$self->{'owner'} = undef unless exists $self->{'owner'};
# Attribute 0x87631a4 name = ownerScope, type = Foundation::Data_Types::ScopeKind, multiplicity = 1

	  if ( exists $self->{'ownerScope'} ) {
	    my $x = $self->{'ownerScope'};
	    $self->{'ownerScope'} = undef;
	    $self->set_ownerScope($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8752534 name = visibility, type = Foundation::Data_Types::VisibilityKind, multiplicity = 1

	  if ( exists $self->{'visibility'} ) {
	    my $x = $self->{'visibility'};
	    $self->{'visibility'} = undef;
	    $self->set_visibility($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x875aa94 name = owner, type = Foundation::Core::Classifier multiplicity = 0..1

	      if ( defined $self->{'owner'} ) {
		my $x = $self->{'owner'};
		$self->{'owner'} = undef;
		$self->set_owner($x);
	      }
	    

  $self;
}

# AssociationEnd 0x875aa94 name = owner, type = Foundation::Core::Classifier multiplicity = 0..1

	      sub owner {
		my ($self) = @_;
		
		$self->{'owner'};
	      }
	      sub set_owner {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'owner'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($new, 'owner');
  ;
		  $self->{'owner'} = $new;        # Recursion lock
		  # AssociationEnd 0x870ef54 name = feature, type = Foundation::Core::Feature, multiplicity = *

	  $old->remove_feature($self) if $old;
	  $new->add_feature($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x87631a4 name = ownerScope, type = Foundation::Data_Types::ScopeKind, multiplicity = 1

	  sub ownerScope {
	    my ($self) = @_;

	    $self->{'ownerScope'};
	  }
	  sub set_ownerScope {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ScopeKind')
    ->__typecheck($new, 'ownerScope');
  ;

	    $self->{'ownerScope'} = $new;

	    $self;
	  }
	
# Attribute 0x8752534 name = visibility, type = Foundation::Data_Types::VisibilityKind, multiplicity = 1

	  sub visibility {
	    my ($self) = @_;

	    $self->{'visibility'};
	  }
	  sub set_visibility {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::VisibilityKind')
    ->__typecheck($new, 'visibility');
  ;

	    $self->{'visibility'} = $new;

	    $self;
	  }
	


1;

