package UML::MetaModel::Foundation::Core::Flow;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Relationship);

sub __model_name { 'Foundation::Core::Flow' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaFlow { 1 }

sub isaFoundation__Core__Flow { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Flow')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Flow': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize;

# AssociationEnd 0x86baa4c name = source, type = Foundation::Core::ModelElement multiplicity = *
$self->{'source'} = undef unless exists $self->{'source'};
# AssociationEnd 0x8707d24 name = target, type = Foundation::Core::ModelElement multiplicity = *
$self->{'target'} = undef unless exists $self->{'target'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize_associations;

# AssociationEnd 0x86baa4c name = source, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'source'} && @{$self->{'source'}}) {
		my $x = $self->{'source'};
		$self->{'source'} = [ ];
		$self->add_source(@$x);
	      }
	    
# AssociationEnd 0x8707d24 name = target, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'target'} && @{$self->{'target'}}) {
		my $x = $self->{'target'};
		$self->{'target'} = [ ];
		$self->add_target(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86baa4c name = source, type = Foundation::Core::ModelElement multiplicity = *

	      sub source {
		my ($self) = @_;
		
		my $x = $self->{'source'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_source {
		my ($self, @new) = @_;
		
		$self->clear_source;
		$self->add_source(@new);
	      }
	      sub add_source {
		my ($self, @new) = @_;
		
		my $x = $self->{'source'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'source');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8716e5c name = sourceFlow, type = Foundation::Core::Flow, multiplicity = *

	  $old->remove_sourceFlow($self) if $old;
	  $new->add_sourceFlow($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_source {
		my ($self, @new) = @_;

		my $x = $self->{'source'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'source');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8716e5c name = sourceFlow, type = Foundation::Core::Flow, multiplicity = *

	  $old->remove_sourceFlow($self) if $old;
	  $new->add_sourceFlow($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_source {
		my ($self) = @_;

		my $x = $self->{'source'} ||= [ ];
		my $new; # Place holder

		$self->{'source'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8716e5c name = sourceFlow, type = Foundation::Core::Flow, multiplicity = *

	  $old->remove_sourceFlow($self) if $old;
	  $new->add_sourceFlow($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x8707d24 name = target, type = Foundation::Core::ModelElement multiplicity = *

	      sub target {
		my ($self) = @_;
		
		my $x = $self->{'target'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_target {
		my ($self, @new) = @_;
		
		$self->clear_target;
		$self->add_target(@new);
	      }
	      sub add_target {
		my ($self, @new) = @_;
		
		my $x = $self->{'target'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'target');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x87331a8 name = targetFlow, type = Foundation::Core::Flow, multiplicity = *

	  $old->remove_targetFlow($self) if $old;
	  $new->add_targetFlow($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_target {
		my ($self, @new) = @_;

		my $x = $self->{'target'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'target');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x87331a8 name = targetFlow, type = Foundation::Core::Flow, multiplicity = *

	  $old->remove_targetFlow($self) if $old;
	  $new->add_targetFlow($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_target {
		my ($self) = @_;

		my $x = $self->{'target'} ||= [ ];
		my $new; # Place holder

		$self->{'target'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x87331a8 name = targetFlow, type = Foundation::Core::Flow, multiplicity = *

	  $old->remove_targetFlow($self) if $old;
	  $new->add_targetFlow($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

