package UML::MetaModel::Foundation::Core::Method;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::BehavioralFeature);

sub __model_name { 'Foundation::Core::Method' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaMethod { 1 }

sub isaFoundation__Core__Method { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Method')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Method': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::BehavioralFeature::__initialize;

# AssociationEnd 0x86ba8f0 name = specification, type = Foundation::Core::Operation multiplicity = 1
$self->{'specification'} = undef unless exists $self->{'specification'};
# Attribute 0x86e2d44 name = body, type = Foundation::Data_Types::ProcedureExpression, multiplicity = 1

	  if ( exists $self->{'body'} ) {
	    my $x = $self->{'body'};
	    $self->{'body'} = undef;
	    $self->set_body($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::BehavioralFeature::__initialize_associations;

# AssociationEnd 0x86ba8f0 name = specification, type = Foundation::Core::Operation multiplicity = 1

	      if ( defined $self->{'specification'} ) {
		my $x = $self->{'specification'};
		$self->{'specification'} = undef;
		$self->set_specification($x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ba8f0 name = specification, type = Foundation::Core::Operation multiplicity = 1

	      sub specification {
		my ($self) = @_;
		
		$self->{'specification'};
	      }
	      sub set_specification {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'specification'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Operation')
    ->__typecheck($new, 'specification');
  ;
		  $self->{'specification'} = $new;        # Recursion lock
		  # AssociationEnd 0x872da70 name = specification_, type = Foundation::Core::Method, multiplicity = *

	  $old->remove_specification_($self) if $old;
	  $new->add_specification_($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x86e2d44 name = body, type = Foundation::Data_Types::ProcedureExpression, multiplicity = 1

	  sub body {
	    my ($self) = @_;

	    $self->{'body'};
	  }
	  sub set_body {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ProcedureExpression')
    ->__typecheck($new, 'body');
  ;

	    $self->{'body'} = $new;

	    $self;
	  }
	


1;

