package UML::MetaModel::Foundation::Core::Namespace;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::Namespace' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaNamespace { 1 }

sub isaFoundation__Core__Namespace { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Namespace')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Namespace': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x870d9f8 name = ownedElement, type = Foundation::Core::ModelElement multiplicity = *
$self->{'ownedElement'} = undef unless exists $self->{'ownedElement'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x870d9f8 name = ownedElement, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'ownedElement'} && @{$self->{'ownedElement'}}) {
		my $x = $self->{'ownedElement'};
		$self->{'ownedElement'} = [ ];
		$self->add_ownedElement(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x870d9f8 name = ownedElement, type = Foundation::Core::ModelElement multiplicity = *

	      sub ownedElement {
		my ($self) = @_;
		
		my $x = $self->{'ownedElement'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_ownedElement {
		my ($self, @new) = @_;
		
		$self->clear_ownedElement;
		$self->add_ownedElement(@new);
	      }
	      sub add_ownedElement {
		my ($self, @new) = @_;
		
		my $x = $self->{'ownedElement'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'ownedElement');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x871ff44 name = namespace, type = Foundation::Core::Namespace, multiplicity = 0..1

	  $old->set_namespace($self) if $old;
	  $new->set_namespace($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_ownedElement {
		my ($self, @new) = @_;

		my $x = $self->{'ownedElement'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'ownedElement');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x871ff44 name = namespace, type = Foundation::Core::Namespace, multiplicity = 0..1

	  $old->set_namespace($self) if $old;
	  $new->set_namespace($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_ownedElement {
		my ($self) = @_;

		my $x = $self->{'ownedElement'} ||= [ ];
		my $new; # Place holder

		$self->{'ownedElement'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x871ff44 name = namespace, type = Foundation::Core::Namespace, multiplicity = 0..1

	  $old->set_namespace($self) if $old;
	  $new->set_namespace($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

