package UML::MetaModel::Foundation::Core::Parameter;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Core::Parameter' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaParameter { 1 }

sub isaFoundation__Core__Parameter { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Parameter')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Parameter': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x86ba764 name = type, type = Foundation::Core::Classifier multiplicity = 1
$self->{'type'} = undef unless exists $self->{'type'};
# AssociationEnd 0x86ba9bc name = parameter_, type = Foundation::Core::BehavioralFeature multiplicity = 0..1
$self->{'parameter_'} = undef unless exists $self->{'parameter_'};
# Attribute 0x8762e68 name = defaultValue, type = Foundation::Data_Types::Expression, multiplicity = 1

	  if ( exists $self->{'defaultValue'} ) {
	    my $x = $self->{'defaultValue'};
	    $self->{'defaultValue'} = undef;
	    $self->set_defaultValue($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8762f7c name = kind, type = Foundation::Data_Types::ParameterDirectionKind, multiplicity = 1

	  if ( exists $self->{'kind'} ) {
	    my $x = $self->{'kind'};
	    $self->{'kind'} = undef;
	    $self->set_kind($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x86ba764 name = type, type = Foundation::Core::Classifier multiplicity = 1

	      if ( defined $self->{'type'} ) {
		my $x = $self->{'type'};
		$self->{'type'} = undef;
		$self->set_type($x);
	      }
	    
# AssociationEnd 0x86ba9bc name = parameter_, type = Foundation::Core::BehavioralFeature multiplicity = 0..1

	      if ( defined $self->{'parameter_'} ) {
		my $x = $self->{'parameter_'};
		$self->{'parameter_'} = undef;
		$self->set_parameter_($x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ba764 name = type, type = Foundation::Core::Classifier multiplicity = 1

	      sub type {
		my ($self) = @_;
		
		$self->{'type'};
	      }
	      sub set_type {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'type'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($new, 'type');
  ;
		  $self->{'type'} = $new;        # Recursion lock
		  # AssociationEnd 0x86dc244 name = type_, type = Foundation::Core::Parameter, multiplicity = *

	  $old->remove_type_($self) if $old;
	  $new->add_type_($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x86ba9bc name = parameter_, type = Foundation::Core::BehavioralFeature multiplicity = 0..1

	      sub parameter_ {
		my ($self) = @_;
		
		$self->{'parameter_'};
	      }
	      sub set_parameter_ {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'parameter_'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::BehavioralFeature')
    ->__typecheck($new, 'parameter_');
  ;
		  $self->{'parameter_'} = $new;        # Recursion lock
		  # AssociationEnd 0x8729b58 name = parameter, type = Foundation::Core::Parameter, multiplicity = *

	  $old->remove_parameter($self) if $old;
	  $new->add_parameter($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x8762e68 name = defaultValue, type = Foundation::Data_Types::Expression, multiplicity = 1

	  sub defaultValue {
	    my ($self) = @_;

	    $self->{'defaultValue'};
	  }
	  sub set_defaultValue {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Expression')
    ->__typecheck($new, 'defaultValue');
  ;

	    $self->{'defaultValue'} = $new;

	    $self;
	  }
	
# Attribute 0x8762f7c name = kind, type = Foundation::Data_Types::ParameterDirectionKind, multiplicity = 1

	  sub kind {
	    my ($self) = @_;

	    $self->{'kind'};
	  }
	  sub set_kind {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ParameterDirectionKind')
    ->__typecheck($new, 'kind');
  ;

	    $self->{'kind'} = $new;

	    $self;
	  }
	


1;

