package UML::MetaModel::Foundation::Core::PresentationElement;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Element);

sub __model_name { 'Foundation::Core::PresentationElement' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaPresentationElement { 1 }

sub isaFoundation__Core__PresentationElement { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::PresentationElement')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::PresentationElement': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Element::__initialize;

# AssociationEnd 0x86ca5a8 name = subject, type = Foundation::Core::ModelElement multiplicity = *
$self->{'subject'} = undef unless exists $self->{'subject'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Element::__initialize_associations;

# AssociationEnd 0x86ca5a8 name = subject, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'subject'} && @{$self->{'subject'}}) {
		my $x = $self->{'subject'};
		$self->{'subject'} = [ ];
		$self->add_subject(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ca5a8 name = subject, type = Foundation::Core::ModelElement multiplicity = *

	      sub subject {
		my ($self) = @_;
		
		my $x = $self->{'subject'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_subject {
		my ($self, @new) = @_;
		
		$self->clear_subject;
		$self->add_subject(@new);
	      }
	      sub add_subject {
		my ($self, @new) = @_;
		
		my $x = $self->{'subject'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'subject');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86bb704 name = presentation, type = Foundation::Core::PresentationElement, multiplicity = *

	  $old->remove_presentation($self) if $old;
	  $new->add_presentation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_subject {
		my ($self, @new) = @_;

		my $x = $self->{'subject'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'subject');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86bb704 name = presentation, type = Foundation::Core::PresentationElement, multiplicity = *

	  $old->remove_presentation($self) if $old;
	  $new->add_presentation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_subject {
		my ($self) = @_;

		my $x = $self->{'subject'} ||= [ ];
		my $new; # Place holder

		$self->{'subject'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86bb704 name = presentation, type = Foundation::Core::PresentationElement, multiplicity = *

	  $old->remove_presentation($self) if $old;
	  $new->add_presentation($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

