package UML::MetaModel::Foundation::Core::TemplateArgument;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Element);

sub __model_name { 'Foundation::Core::TemplateArgument' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaTemplateArgument { 1 }

sub isaFoundation__Core__TemplateArgument { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::TemplateArgument')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::TemplateArgument': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Element::__initialize;

# AssociationEnd 0x86ca3d4 name = modelElement, type = Foundation::Core::ModelElement multiplicity = 1
$self->{'modelElement'} = undef unless exists $self->{'modelElement'};
# AssociationEnd 0x86ca4e8 name = binding, type = Foundation::Core::Binding multiplicity = 1
$self->{'binding'} = undef unless exists $self->{'binding'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Element::__initialize_associations;

# AssociationEnd 0x86ca3d4 name = modelElement, type = Foundation::Core::ModelElement multiplicity = 1

	      if ( defined $self->{'modelElement'} ) {
		my $x = $self->{'modelElement'};
		$self->{'modelElement'} = undef;
		$self->set_modelElement($x);
	      }
	    
# AssociationEnd 0x86ca4e8 name = binding, type = Foundation::Core::Binding multiplicity = 1

	      if ( defined $self->{'binding'} ) {
		my $x = $self->{'binding'};
		$self->{'binding'} = undef;
		$self->set_binding($x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ca3d4 name = modelElement, type = Foundation::Core::ModelElement multiplicity = 1

	      sub modelElement {
		my ($self) = @_;
		
		$self->{'modelElement'};
	      }
	      sub set_modelElement {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'modelElement'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'modelElement');
  ;
		  $self->{'modelElement'} = $new;        # Recursion lock
		  # AssociationEnd 0x86ca308 name = modelElement_, type = Foundation::Core::TemplateArgument, multiplicity = *

	  $old->remove_modelElement_($self) if $old;
	  $new->add_modelElement_($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x86ca4e8 name = binding, type = Foundation::Core::Binding multiplicity = 1

	      sub binding {
		my ($self) = @_;
		
		$self->{'binding'};
	      }
	      sub set_binding {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'binding'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Binding')
    ->__typecheck($new, 'binding');
  ;
		  $self->{'binding'} = $new;        # Recursion lock
		  # AssociationEnd 0x875eb14 name = argument, type = Foundation::Core::TemplateArgument, multiplicity = 1..*

	  $old->remove_argument($self) if $old;
	  $new->add_argument($self) if $new;
	;
		}

		$self;
	      }
	    


1;

