package UML::MetaModel::Foundation::Data_Types::MultiplicityRange;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::__ObjectBase);

sub __model_name { 'Foundation::Data_Types::MultiplicityRange' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaMultiplicityRange { 1 }

sub isaFoundation__Data_Types__MultiplicityRange { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Data_Types::MultiplicityRange')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Data_Types::MultiplicityRange': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::__ObjectBase::__initialize;

# AssociationEnd 0x8737b94 name = range_, type = Foundation::Data_Types::Multiplicity multiplicity = 1
$self->{'range_'} = undef unless exists $self->{'range_'};
# Attribute 0x86d58ac name = lower, type = Foundation::Data_Types::Integer, multiplicity = 1

	  if ( exists $self->{'lower'} ) {
	    my $x = $self->{'lower'};
	    $self->{'lower'} = undef;
	    $self->set_lower($x);
	  } else {
	    ;
	  }
	
# Attribute 0x86d58f4 name = upper, type = Foundation::Data_Types::UnlimitedInteger, multiplicity = 1

	  if ( exists $self->{'upper'} ) {
	    my $x = $self->{'upper'};
	    $self->{'upper'} = undef;
	    $self->set_upper($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::__ObjectBase::__initialize_associations;

# AssociationEnd 0x8737b94 name = range_, type = Foundation::Data_Types::Multiplicity multiplicity = 1

	      if ( defined $self->{'range_'} ) {
		my $x = $self->{'range_'};
		$self->{'range_'} = undef;
		$self->set_range_($x);
	      }
	    

  $self;
}

# AssociationEnd 0x8737b94 name = range_, type = Foundation::Data_Types::Multiplicity multiplicity = 1

	      sub range_ {
		my ($self) = @_;
		
		$self->{'range_'};
	      }
	      sub set_range_ {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'range_'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Multiplicity')
    ->__typecheck($new, 'range_');
  ;
		  $self->{'range_'} = $new;        # Recursion lock
		  # AssociationEnd 0x8683b4c name = range, type = Foundation::Data_Types::MultiplicityRange, multiplicity = 1..*

	  $old->remove_range($self) if $old;
	  $new->add_range($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x86d58ac name = lower, type = Foundation::Data_Types::Integer, multiplicity = 1

	  sub lower {
	    my ($self) = @_;

	    $self->{'lower'};
	  }
	  sub set_lower {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Integer')
    ->__typecheck($new, 'lower');
  ;

	    $self->{'lower'} = $new;

	    $self;
	  }
	
# Attribute 0x86d58f4 name = upper, type = Foundation::Data_Types::UnlimitedInteger, multiplicity = 1

	  sub upper {
	    my ($self) = @_;

	    $self->{'upper'};
	  }
	  sub set_upper {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::UnlimitedInteger')
    ->__typecheck($new, 'upper');
  ;

	    $self->{'upper'} = $new;

	    $self;
	  }
	


1;

