package UML::MetaModel::Foundation::Extension_Mechanisms::TagDefinition;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Extension_Mechanisms::TagDefinition' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaTagDefinition { 1 }

sub isaFoundation__Extension_Mechanisms__TagDefinition { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Extension_Mechanisms::TagDefinition')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Extension_Mechanisms::TagDefinition': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x86ccab0 name = owner, type = Foundation::Extension_Mechanisms::Stereotype multiplicity = 0..1
$self->{'owner'} = undef unless exists $self->{'owner'};
# AssociationEnd 0x872bb5c name = typedValue, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = *
$self->{'typedValue'} = undef unless exists $self->{'typedValue'};
# Attribute 0x8734ba8 name = tagType, type = Foundation::Data_Types::Name, multiplicity = 1

	  if ( exists $self->{'tagType'} ) {
	    my $x = $self->{'tagType'};
	    $self->{'tagType'} = undef;
	    $self->set_tagType($x);
	  } else {
	    ;
	  }
	
# Attribute 0x8734cec name = multiplicity, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  if ( exists $self->{'multiplicity'} ) {
	    my $x = $self->{'multiplicity'};
	    $self->{'multiplicity'} = undef;
	    $self->set_multiplicity($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x86ccab0 name = owner, type = Foundation::Extension_Mechanisms::Stereotype multiplicity = 0..1

	      if ( defined $self->{'owner'} ) {
		my $x = $self->{'owner'};
		$self->{'owner'} = undef;
		$self->set_owner($x);
	      }
	    
# AssociationEnd 0x872bb5c name = typedValue, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = *

	      if ( defined $self->{'typedValue'} && @{$self->{'typedValue'}}) {
		my $x = $self->{'typedValue'};
		$self->{'typedValue'} = [ ];
		$self->add_typedValue(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86ccab0 name = owner, type = Foundation::Extension_Mechanisms::Stereotype multiplicity = 0..1

	      sub owner {
		my ($self) = @_;
		
		$self->{'owner'};
	      }
	      sub set_owner {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'owner'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::Stereotype')
    ->__typecheck($new, 'owner');
  ;
		  $self->{'owner'} = $new;        # Recursion lock
		  # AssociationEnd 0x872ba9c name = definedTag, type = Foundation::Extension_Mechanisms::TagDefinition, multiplicity = *

	  $old->remove_definedTag($self) if $old;
	  $new->add_definedTag($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x872bb5c name = typedValue, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = *

	      sub typedValue {
		my ($self) = @_;
		
		my $x = $self->{'typedValue'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_typedValue {
		my ($self, @new) = @_;
		
		$self->clear_typedValue;
		$self->add_typedValue(@new);
	      }
	      sub add_typedValue {
		my ($self, @new) = @_;
		
		my $x = $self->{'typedValue'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue')
    ->__typecheck($new, 'typedValue');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x870d0dc name = type, type = Foundation::Extension_Mechanisms::TagDefinition, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_typedValue {
		my ($self, @new) = @_;

		my $x = $self->{'typedValue'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue')
    ->__typecheck($old, 'typedValue');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x870d0dc name = type, type = Foundation::Extension_Mechanisms::TagDefinition, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_typedValue {
		my ($self) = @_;

		my $x = $self->{'typedValue'} ||= [ ];
		my $new; # Place holder

		$self->{'typedValue'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x870d0dc name = type, type = Foundation::Extension_Mechanisms::TagDefinition, multiplicity = 1

	  $old->set_type($self) if $old;
	  $new->set_type($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x8734ba8 name = tagType, type = Foundation::Data_Types::Name, multiplicity = 1

	  sub tagType {
	    my ($self) = @_;

	    $self->{'tagType'};
	  }
	  sub set_tagType {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Name')
    ->__typecheck($new, 'tagType');
  ;

	    $self->{'tagType'} = $new;

	    $self;
	  }
	
# Attribute 0x8734cec name = multiplicity, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  sub multiplicity {
	    my ($self) = @_;

	    $self->{'multiplicity'};
	  }
	  sub set_multiplicity {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Multiplicity')
    ->__typecheck($new, 'multiplicity');
  ;

	    $self->{'multiplicity'} = $new;

	    $self;
	  }
	


1;

