package UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::ModelElement);

sub __model_name { 'Foundation::Extension_Mechanisms::TaggedValue' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaTaggedValue { 1 }

sub isaFoundation__Extension_Mechanisms__TaggedValue { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize;

# AssociationEnd 0x870d0dc name = type, type = Foundation::Extension_Mechanisms::TagDefinition multiplicity = 1
$self->{'type'} = undef unless exists $self->{'type'};
# AssociationEnd 0x872bc34 name = taggedValue_, type = Foundation::Core::ModelElement multiplicity = 1
$self->{'taggedValue_'} = undef unless exists $self->{'taggedValue_'};
# AssociationEnd 0x872bcf4 name = referenceValue, type = Foundation::Core::ModelElement multiplicity = *
$self->{'referenceValue'} = undef unless exists $self->{'referenceValue'};
# Attribute 0x86a1458 name = dataValue, type = Foundation::Data_Types::String, multiplicity = *
$self->{'dataValue'} = undef unless exists $self->{'dataValue'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::ModelElement::__initialize_associations;

# AssociationEnd 0x870d0dc name = type, type = Foundation::Extension_Mechanisms::TagDefinition multiplicity = 1

	      if ( defined $self->{'type'} ) {
		my $x = $self->{'type'};
		$self->{'type'} = undef;
		$self->set_type($x);
	      }
	    
# AssociationEnd 0x872bc34 name = taggedValue_, type = Foundation::Core::ModelElement multiplicity = 1

	      if ( defined $self->{'taggedValue_'} ) {
		my $x = $self->{'taggedValue_'};
		$self->{'taggedValue_'} = undef;
		$self->set_taggedValue_($x);
	      }
	    
# AssociationEnd 0x872bcf4 name = referenceValue, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'referenceValue'} && @{$self->{'referenceValue'}}) {
		my $x = $self->{'referenceValue'};
		$self->{'referenceValue'} = [ ];
		$self->add_referenceValue(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x870d0dc name = type, type = Foundation::Extension_Mechanisms::TagDefinition multiplicity = 1

	      sub type {
		my ($self) = @_;
		
		$self->{'type'};
	      }
	      sub set_type {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'type'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TagDefinition')
    ->__typecheck($new, 'type');
  ;
		  $self->{'type'} = $new;        # Recursion lock
		  # AssociationEnd 0x872bb5c name = typedValue, type = Foundation::Extension_Mechanisms::TaggedValue, multiplicity = *

	  $old->remove_typedValue($self) if $old;
	  $new->add_typedValue($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x872bc34 name = taggedValue_, type = Foundation::Core::ModelElement multiplicity = 1

	      sub taggedValue_ {
		my ($self) = @_;
		
		$self->{'taggedValue_'};
	      }
	      sub set_taggedValue_ {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'taggedValue_'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'taggedValue_');
  ;
		  $self->{'taggedValue_'} = $new;        # Recursion lock
		  # AssociationEnd 0x872d1b0 name = taggedValue, type = Foundation::Extension_Mechanisms::TaggedValue, multiplicity = 1

	  $old->set_taggedValue($self) if $old;
	  $new->set_taggedValue($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x872bcf4 name = referenceValue, type = Foundation::Core::ModelElement multiplicity = *

	      sub referenceValue {
		my ($self) = @_;
		
		my $x = $self->{'referenceValue'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_referenceValue {
		my ($self, @new) = @_;
		
		$self->clear_referenceValue;
		$self->add_referenceValue(@new);
	      }
	      sub add_referenceValue {
		my ($self, @new) = @_;
		
		my $x = $self->{'referenceValue'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'referenceValue');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8703d38 name = referenceTag, type = Foundation::Extension_Mechanisms::TaggedValue, multiplicity = *

	  $old->remove_referenceTag($self) if $old;
	  $new->add_referenceTag($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_referenceValue {
		my ($self, @new) = @_;

		my $x = $self->{'referenceValue'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'referenceValue');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8703d38 name = referenceTag, type = Foundation::Extension_Mechanisms::TaggedValue, multiplicity = *

	  $old->remove_referenceTag($self) if $old;
	  $new->add_referenceTag($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_referenceValue {
		my ($self) = @_;

		my $x = $self->{'referenceValue'} ||= [ ];
		my $new; # Place holder

		$self->{'referenceValue'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8703d38 name = referenceTag, type = Foundation::Extension_Mechanisms::TaggedValue, multiplicity = *

	  $old->remove_referenceTag($self) if $old;
	  $new->add_referenceTag($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x86a1458 name = dataValue, type = Foundation::Data_Types::String, multiplicity = *

	  sub dataValue {
	    my ($self) = @_;
	    
	    my $x = $self->{'dataValue'};
	    wantarray ? @{$x} : $x;
	  }
	  sub set_dataValue {
	    my ($self, @new) = @_;
	    
	    for my $new ( @new ) { 
	      
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::String')
    ->__typecheck($new, 'dataValue');
  ;
	    }
	    
	    $self->{'dataValue'} = [ @new ];
	    
	    $self;
	  }
	  sub add_dataValue {
	    my ($self, @new) = @_;
	    
	    for my $new ( @new ) { 
	      
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::String')
    ->__typecheck($new, 'dataValue');
  ;
	    }
	    push(@{$self->{'dataValue'} ||= [ ]}, @new);
	    
	    $self;
	  }
	  sub remove_dataValue {
	    my ($self, @new) = @_;
	    for my $new ( @new ) { 
	      
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::String')
    ->__typecheck($new, 'dataValue');
  ;
	    }
	    my $x = $self->{'dataValue'} ||= [ ];
	    for my $new ( @new ) {
	      @$x = grep($_ ne $new, @$x);
	    }
	    
	    $self;
	  }
	


1;

