#!/usr/local/bin/perl

use 5.6.1;
use strict;
use warnings;


use lib "../lib/perl";
use lib "gen";


use UML::MetaModel;

$DB::single = 1;

my $f = UML::MetaModel->factory;

$DB::single = 1;

my $root = $f->create('Model');

$DB::single = 1;
my $cls = $f->create('Class', 
		     'name' => 'AClass',
		     'namespace' => $root,
		     );

$DB::single = 1;
my $attr = $f->create('Attribute',
		      'type' => $cls,
		      'name' => 'foobar',
		      'visibility' => 'public',
		      'owner' => $cls,
		      );

use Data::Dumper;

print STDERR Data::Dumper->new([$attr])->Dump;

$DB::single = 1;

1;
