package UML::MetaModel::Foundation::Core::Abstraction;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Dependency);

sub __model_name { 'Foundation::Core::Abstraction' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaAbstraction { 1 }

sub isaFoundation__Core__Abstraction { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Abstraction')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Abstraction': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Dependency::__initialize;

# Attribute 0x86d4368 name = mapping, type = Foundation::Data_Types::MappingExpression, multiplicity = 1

	  if ( exists $self->{'mapping'} ) {
	    my $x = $self->{'mapping'};
	    $self->{'mapping'} = undef;
	    $self->set_mapping($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Dependency::__initialize_associations;


  $self;
}

# Attribute 0x86d4368 name = mapping, type = Foundation::Data_Types::MappingExpression, multiplicity = 1

	  sub mapping {
	    my ($self) = @_;

	    $self->{'mapping'};
	  }
	  sub set_mapping {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::MappingExpression')
    ->__typecheck($new, 'mapping');
  ;

	    $self->{'mapping'} = $new;

	    $self;
	  }
	


1;

