package UML::MetaModel::Foundation::Core::BehavioralFeature;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Feature);

sub __model_name { 'Foundation::Core::BehavioralFeature' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaBehavioralFeature { 1 }

sub isaFoundation__Core__BehavioralFeature { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::BehavioralFeature')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::BehavioralFeature': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Feature::__initialize;

# AssociationEnd 0x8729b58 name = parameter, type = Foundation::Core::Parameter multiplicity = *
$self->{'parameter'} = undef unless exists $self->{'parameter'};
# Attribute 0x86faca0 name = isQuery, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isQuery'} ) {
	    my $x = $self->{'isQuery'};
	    $self->{'isQuery'} = undef;
	    $self->set_isQuery($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Feature::__initialize_associations;

# AssociationEnd 0x8729b58 name = parameter, type = Foundation::Core::Parameter multiplicity = *

	      if ( defined $self->{'parameter'} && @{$self->{'parameter'}}) {
		my $x = $self->{'parameter'};
		$self->{'parameter'} = [ ];
		$self->add_parameter(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x8729b58 name = parameter, type = Foundation::Core::Parameter multiplicity = *

	      sub parameter {
		my ($self) = @_;
		
		my $x = $self->{'parameter'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_parameter {
		my ($self, @new) = @_;
		
		$self->clear_parameter;
		$self->add_parameter(@new);
	      }
	      sub add_parameter {
		my ($self, @new) = @_;
		
		my $x = $self->{'parameter'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Parameter')
    ->__typecheck($new, 'parameter');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ba9bc name = parameter_, type = Foundation::Core::BehavioralFeature, multiplicity = 0..1

	  $old->set_parameter_($self) if $old;
	  $new->set_parameter_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_parameter {
		my ($self, @new) = @_;

		my $x = $self->{'parameter'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Parameter')
    ->__typecheck($old, 'parameter');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ba9bc name = parameter_, type = Foundation::Core::BehavioralFeature, multiplicity = 0..1

	  $old->set_parameter_($self) if $old;
	  $new->set_parameter_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_parameter {
		my ($self) = @_;

		my $x = $self->{'parameter'} ||= [ ];
		my $new; # Place holder

		$self->{'parameter'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ba9bc name = parameter_, type = Foundation::Core::BehavioralFeature, multiplicity = 0..1

	  $old->set_parameter_($self) if $old;
	  $new->set_parameter_($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x86faca0 name = isQuery, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isQuery {
	    my ($self) = @_;

	    $self->{'isQuery'};
	  }
	  sub set_isQuery {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isQuery');
  ;

	    $self->{'isQuery'} = $new;

	    $self;
	  }
	


1;

