package UML::MetaModel::Foundation::Core::Binding;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Dependency);

sub __model_name { 'Foundation::Core::Binding' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaBinding { 1 }

sub isaFoundation__Core__Binding { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Binding')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Binding': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Dependency::__initialize;

# AssociationEnd 0x875eb14 name = argument, type = Foundation::Core::TemplateArgument multiplicity = 1..*
$self->{'argument'} = undef unless exists $self->{'argument'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Dependency::__initialize_associations;

# AssociationEnd 0x875eb14 name = argument, type = Foundation::Core::TemplateArgument multiplicity = 1..*

	      if ( defined $self->{'argument'} && @{$self->{'argument'}}) {
		my $x = $self->{'argument'};
		$self->{'argument'} = [ ];
		$self->add_argument(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x875eb14 name = argument, type = Foundation::Core::TemplateArgument multiplicity = 1..*

	      sub argument {
		my ($self) = @_;
		
		my $x = $self->{'argument'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_argument {
		my ($self, @new) = @_;
		
		$self->clear_argument;
		$self->add_argument(@new);
	      }
	      sub add_argument {
		my ($self, @new) = @_;
		
		my $x = $self->{'argument'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::TemplateArgument')
    ->__typecheck($new, 'argument');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ca4e8 name = binding, type = Foundation::Core::Binding, multiplicity = 1

	  $old->set_binding($self) if $old;
	  $new->set_binding($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_argument {
		my ($self, @new) = @_;

		my $x = $self->{'argument'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::TemplateArgument')
    ->__typecheck($old, 'argument');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ca4e8 name = binding, type = Foundation::Core::Binding, multiplicity = 1

	  $old->set_binding($self) if $old;
	  $new->set_binding($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_argument {
		my ($self) = @_;

		my $x = $self->{'argument'} ||= [ ];
		my $new; # Place holder

		$self->{'argument'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ca4e8 name = binding, type = Foundation::Core::Binding, multiplicity = 1

	  $old->set_binding($self) if $old;
	  $new->set_binding($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

