package UML::MetaModel::Foundation::Core::Class;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Classifier);

sub __model_name { 'Foundation::Core::Class' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaClass { 1 }

sub isaFoundation__Core__Class { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Class')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Class': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize;

# Attribute 0x86d4458 name = isActive, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isActive'} ) {
	    my $x = $self->{'isActive'};
	    $self->{'isActive'} = undef;
	    $self->set_isActive($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize_associations;


  $self;
}

# Attribute 0x86d4458 name = isActive, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isActive {
	    my ($self) = @_;

	    $self->{'isActive'};
	  }
	  sub set_isActive {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isActive');
  ;

	    $self->{'isActive'} = $new;

	    $self;
	  }
	


1;

