package UML::MetaModel::Foundation::Core::Dependency;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Relationship);

sub __model_name { 'Foundation::Core::Dependency' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaDependency { 1 }

sub isaFoundation__Core__Dependency { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Dependency')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Dependency': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize;

# AssociationEnd 0x8736f34 name = supplier, type = Foundation::Core::ModelElement multiplicity = 1..*
$self->{'supplier'} = undef unless exists $self->{'supplier'};
# AssociationEnd 0x86f9620 name = client, type = Foundation::Core::ModelElement multiplicity = 1..*
$self->{'client'} = undef unless exists $self->{'client'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Relationship::__initialize_associations;

# AssociationEnd 0x8736f34 name = supplier, type = Foundation::Core::ModelElement multiplicity = 1..*

	      if ( defined $self->{'supplier'} && @{$self->{'supplier'}}) {
		my $x = $self->{'supplier'};
		$self->{'supplier'} = [ ];
		$self->add_supplier(@$x);
	      }
	    
# AssociationEnd 0x86f9620 name = client, type = Foundation::Core::ModelElement multiplicity = 1..*

	      if ( defined $self->{'client'} && @{$self->{'client'}}) {
		my $x = $self->{'client'};
		$self->{'client'} = [ ];
		$self->add_client(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x8736f34 name = supplier, type = Foundation::Core::ModelElement multiplicity = 1..*

	      sub supplier {
		my ($self) = @_;
		
		my $x = $self->{'supplier'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_supplier {
		my ($self, @new) = @_;
		
		$self->clear_supplier;
		$self->add_supplier(@new);
	      }
	      sub add_supplier {
		my ($self, @new) = @_;
		
		my $x = $self->{'supplier'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'supplier');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ba538 name = supplierDependency, type = Foundation::Core::Dependency, multiplicity = *

	  $old->remove_supplierDependency($self) if $old;
	  $new->add_supplierDependency($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_supplier {
		my ($self, @new) = @_;

		my $x = $self->{'supplier'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'supplier');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ba538 name = supplierDependency, type = Foundation::Core::Dependency, multiplicity = *

	  $old->remove_supplierDependency($self) if $old;
	  $new->add_supplierDependency($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_supplier {
		my ($self) = @_;

		my $x = $self->{'supplier'} ||= [ ];
		my $new; # Place holder

		$self->{'supplier'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ba538 name = supplierDependency, type = Foundation::Core::Dependency, multiplicity = *

	  $old->remove_supplierDependency($self) if $old;
	  $new->add_supplierDependency($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86f9620 name = client, type = Foundation::Core::ModelElement multiplicity = 1..*

	      sub client {
		my ($self) = @_;
		
		my $x = $self->{'client'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_client {
		my ($self, @new) = @_;
		
		$self->clear_client;
		$self->add_client(@new);
	      }
	      sub add_client {
		my ($self, @new) = @_;
		
		my $x = $self->{'client'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'client');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875a5d4 name = clientDependency, type = Foundation::Core::Dependency, multiplicity = *

	  $old->remove_clientDependency($self) if $old;
	  $new->add_clientDependency($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_client {
		my ($self, @new) = @_;

		my $x = $self->{'client'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'client');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875a5d4 name = clientDependency, type = Foundation::Core::Dependency, multiplicity = *

	  $old->remove_clientDependency($self) if $old;
	  $new->add_clientDependency($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_client {
		my ($self) = @_;

		my $x = $self->{'client'} ||= [ ];
		my $new; # Place holder

		$self->{'client'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875a5d4 name = clientDependency, type = Foundation::Core::Dependency, multiplicity = *

	  $old->remove_clientDependency($self) if $old;
	  $new->add_clientDependency($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

