package UML::MetaModel::Foundation::Core::Enumeration;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::DataType);

sub __model_name { 'Foundation::Core::Enumeration' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaEnumeration { 1 }

sub isaFoundation__Core__Enumeration { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Enumeration')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Enumeration': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::DataType::__initialize;

# AssociationEnd 0x86c9fd8 name = literal, type = Foundation::Core::EnumerationLiteral multiplicity = 1..*
$self->{'literal'} = undef unless exists $self->{'literal'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::DataType::__initialize_associations;

# AssociationEnd 0x86c9fd8 name = literal, type = Foundation::Core::EnumerationLiteral multiplicity = 1..*

	      if ( defined $self->{'literal'} && @{$self->{'literal'}}) {
		my $x = $self->{'literal'};
		$self->{'literal'} = [ ];
		$self->add_literal(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x86c9fd8 name = literal, type = Foundation::Core::EnumerationLiteral multiplicity = 1..*

	      sub literal {
		my ($self) = @_;
		
		my $x = $self->{'literal'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_literal {
		my ($self, @new) = @_;
		
		$self->clear_literal;
		$self->add_literal(@new);
	      }
	      sub add_literal {
		my ($self, @new) = @_;
		
		my $x = $self->{'literal'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::EnumerationLiteral')
    ->__typecheck($new, 'literal');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875eedc name = enumeration, type = Foundation::Core::Enumeration, multiplicity = 1

	  $old->set_enumeration($self) if $old;
	  $new->set_enumeration($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_literal {
		my ($self, @new) = @_;

		my $x = $self->{'literal'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::EnumerationLiteral')
    ->__typecheck($old, 'literal');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875eedc name = enumeration, type = Foundation::Core::Enumeration, multiplicity = 1

	  $old->set_enumeration($self) if $old;
	  $new->set_enumeration($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_literal {
		my ($self) = @_;

		my $x = $self->{'literal'} ||= [ ];
		my $new; # Place holder

		$self->{'literal'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875eedc name = enumeration, type = Foundation::Core::Enumeration, multiplicity = 1

	  $old->set_enumeration($self) if $old;
	  $new->set_enumeration($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

