package UML::MetaModel::Foundation::Core::ModelElement;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Element);

sub __model_name { 'Foundation::Core::ModelElement' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaModelElement { 1 }

sub isaFoundation__Core__ModelElement { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::ModelElement')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::ModelElement': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Element::__initialize;

# AssociationEnd 0x871ff44 name = namespace, type = Foundation::Core::Namespace multiplicity = 0..1
$self->{'namespace'} = undef unless exists $self->{'namespace'};
# AssociationEnd 0x870d9bc name = constraint, type = Foundation::Core::Constraint multiplicity = *
$self->{'constraint'} = undef unless exists $self->{'constraint'};
# AssociationEnd 0x8716e5c name = sourceFlow, type = Foundation::Core::Flow multiplicity = *
$self->{'sourceFlow'} = undef unless exists $self->{'sourceFlow'};
# AssociationEnd 0x87331a8 name = targetFlow, type = Foundation::Core::Flow multiplicity = *
$self->{'targetFlow'} = undef unless exists $self->{'targetFlow'};
# AssociationEnd 0x8707b44 name = specialization, type = Foundation::Core::Generalization multiplicity = *
$self->{'specialization'} = undef unless exists $self->{'specialization'};
# AssociationEnd 0x86ba538 name = supplierDependency, type = Foundation::Core::Dependency multiplicity = *
$self->{'supplierDependency'} = undef unless exists $self->{'supplierDependency'};
# AssociationEnd 0x875a5d4 name = clientDependency, type = Foundation::Core::Dependency multiplicity = *
$self->{'clientDependency'} = undef unless exists $self->{'clientDependency'};
# AssociationEnd 0x87543e0 name = container, type = Foundation::Core::Component multiplicity = *
$self->{'container'} = undef unless exists $self->{'container'};
# AssociationEnd 0x875f020 name = defaultElement_, type = Foundation::Core::TemplateParameter multiplicity = 1
$self->{'defaultElement_'} = undef unless exists $self->{'defaultElement_'};
# AssociationEnd 0x86ca2fc name = template, type = Foundation::Core::ModelElement multiplicity = 1..*
$self->{'template'} = undef unless exists $self->{'template'};
# AssociationEnd 0x875f290 name = templateParameter, type = Foundation::Core::ModelElement multiplicity = *
$self->{'templateParameter'} = undef unless exists $self->{'templateParameter'};
# AssociationEnd 0x86ca308 name = modelElement_, type = Foundation::Core::TemplateArgument multiplicity = *
$self->{'modelElement_'} = undef unless exists $self->{'modelElement_'};
# AssociationEnd 0x86bb704 name = presentation, type = Foundation::Core::PresentationElement multiplicity = *
$self->{'presentation'} = undef unless exists $self->{'presentation'};
# AssociationEnd 0x86bb98c name = annotatedElement_, type = Foundation::Core::Comment multiplicity = *
$self->{'annotatedElement_'} = undef unless exists $self->{'annotatedElement_'};
# AssociationEnd 0x872d1b0 name = taggedValue, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = 1
$self->{'taggedValue'} = undef unless exists $self->{'taggedValue'};
# AssociationEnd 0x8703d38 name = referenceTag, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = *
$self->{'referenceTag'} = undef unless exists $self->{'referenceTag'};
# AssociationEnd 0x8703ea0 name = importedElement_, type = Foundation::Model_Management::Package multiplicity = *
$self->{'importedElement_'} = undef unless exists $self->{'importedElement_'};
# Attribute 0x869a6c0 name = name, type = Foundation::Data_Types::Name, multiplicity = 1

	  if ( exists $self->{'name'} ) {
	    my $x = $self->{'name'};
	    $self->{'name'} = undef;
	    $self->set_name($x);
	  } else {
	    ;
	  }
	
# Attribute 0x874f72c name = visibility, type = Foundation::Data_Types::VisibilityKind, multiplicity = 1

	  if ( exists $self->{'visibility'} ) {
	    my $x = $self->{'visibility'};
	    $self->{'visibility'} = undef;
	    $self->set_visibility($x);
	  } else {
	    ;
	  }
	
# Attribute 0x868e130 name = isSpecification, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  if ( exists $self->{'isSpecification'} ) {
	    my $x = $self->{'isSpecification'};
	    $self->{'isSpecification'} = undef;
	    $self->set_isSpecification($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Element::__initialize_associations;

# AssociationEnd 0x871ff44 name = namespace, type = Foundation::Core::Namespace multiplicity = 0..1

	      if ( defined $self->{'namespace'} ) {
		my $x = $self->{'namespace'};
		$self->{'namespace'} = undef;
		$self->set_namespace($x);
	      }
	    
# AssociationEnd 0x870d9bc name = constraint, type = Foundation::Core::Constraint multiplicity = *

	      if ( defined $self->{'constraint'} && @{$self->{'constraint'}}) {
		my $x = $self->{'constraint'};
		$self->{'constraint'} = [ ];
		$self->add_constraint(@$x);
	      }
	    
# AssociationEnd 0x8716e5c name = sourceFlow, type = Foundation::Core::Flow multiplicity = *

	      if ( defined $self->{'sourceFlow'} && @{$self->{'sourceFlow'}}) {
		my $x = $self->{'sourceFlow'};
		$self->{'sourceFlow'} = [ ];
		$self->add_sourceFlow(@$x);
	      }
	    
# AssociationEnd 0x87331a8 name = targetFlow, type = Foundation::Core::Flow multiplicity = *

	      if ( defined $self->{'targetFlow'} && @{$self->{'targetFlow'}}) {
		my $x = $self->{'targetFlow'};
		$self->{'targetFlow'} = [ ];
		$self->add_targetFlow(@$x);
	      }
	    
# AssociationEnd 0x8707b44 name = specialization, type = Foundation::Core::Generalization multiplicity = *

	      if ( defined $self->{'specialization'} && @{$self->{'specialization'}}) {
		my $x = $self->{'specialization'};
		$self->{'specialization'} = [ ];
		$self->add_specialization(@$x);
	      }
	    
# AssociationEnd 0x86ba538 name = supplierDependency, type = Foundation::Core::Dependency multiplicity = *

	      if ( defined $self->{'supplierDependency'} && @{$self->{'supplierDependency'}}) {
		my $x = $self->{'supplierDependency'};
		$self->{'supplierDependency'} = [ ];
		$self->add_supplierDependency(@$x);
	      }
	    
# AssociationEnd 0x875a5d4 name = clientDependency, type = Foundation::Core::Dependency multiplicity = *

	      if ( defined $self->{'clientDependency'} && @{$self->{'clientDependency'}}) {
		my $x = $self->{'clientDependency'};
		$self->{'clientDependency'} = [ ];
		$self->add_clientDependency(@$x);
	      }
	    
# AssociationEnd 0x87543e0 name = container, type = Foundation::Core::Component multiplicity = *

	      if ( defined $self->{'container'} && @{$self->{'container'}}) {
		my $x = $self->{'container'};
		$self->{'container'} = [ ];
		$self->add_container(@$x);
	      }
	    
# AssociationEnd 0x875f020 name = defaultElement_, type = Foundation::Core::TemplateParameter multiplicity = 1

	      if ( defined $self->{'defaultElement_'} ) {
		my $x = $self->{'defaultElement_'};
		$self->{'defaultElement_'} = undef;
		$self->set_defaultElement_($x);
	      }
	    
# AssociationEnd 0x86ca2fc name = template, type = Foundation::Core::ModelElement multiplicity = 1..*

	      if ( defined $self->{'template'} && @{$self->{'template'}}) {
		my $x = $self->{'template'};
		$self->{'template'} = [ ];
		$self->add_template(@$x);
	      }
	    
# AssociationEnd 0x875f290 name = templateParameter, type = Foundation::Core::ModelElement multiplicity = *

	      if ( defined $self->{'templateParameter'} && @{$self->{'templateParameter'}}) {
		my $x = $self->{'templateParameter'};
		$self->{'templateParameter'} = [ ];
		$self->add_templateParameter(@$x);
	      }
	    
# AssociationEnd 0x86ca308 name = modelElement_, type = Foundation::Core::TemplateArgument multiplicity = *

	      if ( defined $self->{'modelElement_'} && @{$self->{'modelElement_'}}) {
		my $x = $self->{'modelElement_'};
		$self->{'modelElement_'} = [ ];
		$self->add_modelElement_(@$x);
	      }
	    
# AssociationEnd 0x86bb704 name = presentation, type = Foundation::Core::PresentationElement multiplicity = *

	      if ( defined $self->{'presentation'} && @{$self->{'presentation'}}) {
		my $x = $self->{'presentation'};
		$self->{'presentation'} = [ ];
		$self->add_presentation(@$x);
	      }
	    
# AssociationEnd 0x86bb98c name = annotatedElement_, type = Foundation::Core::Comment multiplicity = *

	      if ( defined $self->{'annotatedElement_'} && @{$self->{'annotatedElement_'}}) {
		my $x = $self->{'annotatedElement_'};
		$self->{'annotatedElement_'} = [ ];
		$self->add_annotatedElement_(@$x);
	      }
	    
# AssociationEnd 0x872d1b0 name = taggedValue, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = 1

	      if ( defined $self->{'taggedValue'} ) {
		my $x = $self->{'taggedValue'};
		$self->{'taggedValue'} = undef;
		$self->set_taggedValue($x);
	      }
	    
# AssociationEnd 0x8703d38 name = referenceTag, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = *

	      if ( defined $self->{'referenceTag'} && @{$self->{'referenceTag'}}) {
		my $x = $self->{'referenceTag'};
		$self->{'referenceTag'} = [ ];
		$self->add_referenceTag(@$x);
	      }
	    
# AssociationEnd 0x8703ea0 name = importedElement_, type = Foundation::Model_Management::Package multiplicity = *

	      if ( defined $self->{'importedElement_'} && @{$self->{'importedElement_'}}) {
		my $x = $self->{'importedElement_'};
		$self->{'importedElement_'} = [ ];
		$self->add_importedElement_(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x871ff44 name = namespace, type = Foundation::Core::Namespace multiplicity = 0..1

	      sub namespace {
		my ($self) = @_;
		
		$self->{'namespace'};
	      }
	      sub set_namespace {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'namespace'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Namespace')
    ->__typecheck($new, 'namespace');
  ;
		  $self->{'namespace'} = $new;        # Recursion lock
		  # AssociationEnd 0x870d9f8 name = ownedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_ownedElement($self) if $old;
	  $new->add_ownedElement($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x870d9bc name = constraint, type = Foundation::Core::Constraint multiplicity = *

	      sub constraint {
		my ($self) = @_;
		
		my $x = $self->{'constraint'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_constraint {
		my ($self, @new) = @_;
		
		$self->clear_constraint;
		$self->add_constraint(@new);
	      }
	      sub add_constraint {
		my ($self, @new) = @_;
		
		my $x = $self->{'constraint'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Constraint')
    ->__typecheck($new, 'constraint');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8717024 name = constrainedElement, type = Foundation::Core::ModelElement, multiplicity = 0..1

	  $old->set_constrainedElement($self) if $old;
	  $new->set_constrainedElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_constraint {
		my ($self, @new) = @_;

		my $x = $self->{'constraint'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Constraint')
    ->__typecheck($old, 'constraint');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8717024 name = constrainedElement, type = Foundation::Core::ModelElement, multiplicity = 0..1

	  $old->set_constrainedElement($self) if $old;
	  $new->set_constrainedElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_constraint {
		my ($self) = @_;

		my $x = $self->{'constraint'} ||= [ ];
		my $new; # Place holder

		$self->{'constraint'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8717024 name = constrainedElement, type = Foundation::Core::ModelElement, multiplicity = 0..1

	  $old->set_constrainedElement($self) if $old;
	  $new->set_constrainedElement($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x8716e5c name = sourceFlow, type = Foundation::Core::Flow multiplicity = *

	      sub sourceFlow {
		my ($self) = @_;
		
		my $x = $self->{'sourceFlow'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_sourceFlow {
		my ($self, @new) = @_;
		
		$self->clear_sourceFlow;
		$self->add_sourceFlow(@new);
	      }
	      sub add_sourceFlow {
		my ($self, @new) = @_;
		
		my $x = $self->{'sourceFlow'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Flow')
    ->__typecheck($new, 'sourceFlow');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86baa4c name = source, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_source($self) if $old;
	  $new->add_source($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_sourceFlow {
		my ($self, @new) = @_;

		my $x = $self->{'sourceFlow'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Flow')
    ->__typecheck($old, 'sourceFlow');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86baa4c name = source, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_source($self) if $old;
	  $new->add_source($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_sourceFlow {
		my ($self) = @_;

		my $x = $self->{'sourceFlow'} ||= [ ];
		my $new; # Place holder

		$self->{'sourceFlow'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86baa4c name = source, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_source($self) if $old;
	  $new->add_source($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x87331a8 name = targetFlow, type = Foundation::Core::Flow multiplicity = *

	      sub targetFlow {
		my ($self) = @_;
		
		my $x = $self->{'targetFlow'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_targetFlow {
		my ($self, @new) = @_;
		
		$self->clear_targetFlow;
		$self->add_targetFlow(@new);
	      }
	      sub add_targetFlow {
		my ($self, @new) = @_;
		
		my $x = $self->{'targetFlow'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Flow')
    ->__typecheck($new, 'targetFlow');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8707d24 name = target, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_target($self) if $old;
	  $new->add_target($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_targetFlow {
		my ($self, @new) = @_;

		my $x = $self->{'targetFlow'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Flow')
    ->__typecheck($old, 'targetFlow');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8707d24 name = target, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_target($self) if $old;
	  $new->add_target($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_targetFlow {
		my ($self) = @_;

		my $x = $self->{'targetFlow'} ||= [ ];
		my $new; # Place holder

		$self->{'targetFlow'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8707d24 name = target, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_target($self) if $old;
	  $new->add_target($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x8707b44 name = specialization, type = Foundation::Core::Generalization multiplicity = *

	      sub specialization {
		my ($self) = @_;
		
		my $x = $self->{'specialization'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_specialization {
		my ($self, @new) = @_;
		
		$self->clear_specialization;
		$self->add_specialization(@new);
	      }
	      sub add_specialization {
		my ($self, @new) = @_;
		
		my $x = $self->{'specialization'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Generalization')
    ->__typecheck($new, 'specialization');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875f140 name = parent, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_parent($self) if $old;
	  $new->add_parent($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_specialization {
		my ($self, @new) = @_;

		my $x = $self->{'specialization'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Generalization')
    ->__typecheck($old, 'specialization');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875f140 name = parent, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_parent($self) if $old;
	  $new->add_parent($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_specialization {
		my ($self) = @_;

		my $x = $self->{'specialization'} ||= [ ];
		my $new; # Place holder

		$self->{'specialization'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875f140 name = parent, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_parent($self) if $old;
	  $new->add_parent($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86ba538 name = supplierDependency, type = Foundation::Core::Dependency multiplicity = *

	      sub supplierDependency {
		my ($self) = @_;
		
		my $x = $self->{'supplierDependency'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_supplierDependency {
		my ($self, @new) = @_;
		
		$self->clear_supplierDependency;
		$self->add_supplierDependency(@new);
	      }
	      sub add_supplierDependency {
		my ($self, @new) = @_;
		
		my $x = $self->{'supplierDependency'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Dependency')
    ->__typecheck($new, 'supplierDependency');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8736f34 name = supplier, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_supplier($self) if $old;
	  $new->add_supplier($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_supplierDependency {
		my ($self, @new) = @_;

		my $x = $self->{'supplierDependency'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Dependency')
    ->__typecheck($old, 'supplierDependency');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8736f34 name = supplier, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_supplier($self) if $old;
	  $new->add_supplier($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_supplierDependency {
		my ($self) = @_;

		my $x = $self->{'supplierDependency'} ||= [ ];
		my $new; # Place holder

		$self->{'supplierDependency'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8736f34 name = supplier, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_supplier($self) if $old;
	  $new->add_supplier($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x875a5d4 name = clientDependency, type = Foundation::Core::Dependency multiplicity = *

	      sub clientDependency {
		my ($self) = @_;
		
		my $x = $self->{'clientDependency'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_clientDependency {
		my ($self, @new) = @_;
		
		$self->clear_clientDependency;
		$self->add_clientDependency(@new);
	      }
	      sub add_clientDependency {
		my ($self, @new) = @_;
		
		my $x = $self->{'clientDependency'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Dependency')
    ->__typecheck($new, 'clientDependency');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86f9620 name = client, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_client($self) if $old;
	  $new->add_client($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_clientDependency {
		my ($self, @new) = @_;

		my $x = $self->{'clientDependency'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Dependency')
    ->__typecheck($old, 'clientDependency');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86f9620 name = client, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_client($self) if $old;
	  $new->add_client($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_clientDependency {
		my ($self) = @_;

		my $x = $self->{'clientDependency'} ||= [ ];
		my $new; # Place holder

		$self->{'clientDependency'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86f9620 name = client, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_client($self) if $old;
	  $new->add_client($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x87543e0 name = container, type = Foundation::Core::Component multiplicity = *

	      sub container {
		my ($self) = @_;
		
		my $x = $self->{'container'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_container {
		my ($self, @new) = @_;
		
		$self->clear_container;
		$self->add_container(@new);
	      }
	      sub add_container {
		my ($self, @new) = @_;
		
		my $x = $self->{'container'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Component')
    ->__typecheck($new, 'container');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86c9f48 name = resident, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_resident($self) if $old;
	  $new->add_resident($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_container {
		my ($self, @new) = @_;

		my $x = $self->{'container'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Component')
    ->__typecheck($old, 'container');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86c9f48 name = resident, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_resident($self) if $old;
	  $new->add_resident($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_container {
		my ($self) = @_;

		my $x = $self->{'container'} ||= [ ];
		my $new; # Place holder

		$self->{'container'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86c9f48 name = resident, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_resident($self) if $old;
	  $new->add_resident($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x875f020 name = defaultElement_, type = Foundation::Core::TemplateParameter multiplicity = 1

	      sub defaultElement_ {
		my ($self) = @_;
		
		$self->{'defaultElement_'};
	      }
	      sub set_defaultElement_ {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'defaultElement_'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::TemplateParameter')
    ->__typecheck($new, 'defaultElement_');
  ;
		  $self->{'defaultElement_'} = $new;        # Recursion lock
		  # AssociationEnd 0x86ca158 name = defaultElement, type = Foundation::Core::ModelElement, multiplicity = 0..1

	  $old->set_defaultElement($self) if $old;
	  $new->set_defaultElement($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x86ca2fc name = template, type = Foundation::Core::ModelElement multiplicity = 1..*

	      sub template {
		my ($self) = @_;
		
		my $x = $self->{'template'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_template {
		my ($self, @new) = @_;
		
		$self->clear_template;
		$self->add_template(@new);
	      }
	      sub add_template {
		my ($self, @new) = @_;
		
		my $x = $self->{'template'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'template');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875f290 name = templateParameter, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_templateParameter($self) if $old;
	  $new->add_templateParameter($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_template {
		my ($self, @new) = @_;

		my $x = $self->{'template'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'template');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875f290 name = templateParameter, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_templateParameter($self) if $old;
	  $new->add_templateParameter($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_template {
		my ($self) = @_;

		my $x = $self->{'template'} ||= [ ];
		my $new; # Place holder

		$self->{'template'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875f290 name = templateParameter, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_templateParameter($self) if $old;
	  $new->add_templateParameter($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x875f290 name = templateParameter, type = Foundation::Core::ModelElement multiplicity = *

	      sub templateParameter {
		my ($self) = @_;
		
		my $x = $self->{'templateParameter'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_templateParameter {
		my ($self, @new) = @_;
		
		$self->clear_templateParameter;
		$self->add_templateParameter(@new);
	      }
	      sub add_templateParameter {
		my ($self, @new) = @_;
		
		my $x = $self->{'templateParameter'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($new, 'templateParameter');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ca2fc name = template, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_template($self) if $old;
	  $new->add_template($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_templateParameter {
		my ($self, @new) = @_;

		my $x = $self->{'templateParameter'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::ModelElement')
    ->__typecheck($old, 'templateParameter');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ca2fc name = template, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_template($self) if $old;
	  $new->add_template($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_templateParameter {
		my ($self) = @_;

		my $x = $self->{'templateParameter'} ||= [ ];
		my $new; # Place holder

		$self->{'templateParameter'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ca2fc name = template, type = Foundation::Core::ModelElement, multiplicity = 1..*

	  $old->remove_template($self) if $old;
	  $new->add_template($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86ca308 name = modelElement_, type = Foundation::Core::TemplateArgument multiplicity = *

	      sub modelElement_ {
		my ($self) = @_;
		
		my $x = $self->{'modelElement_'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_modelElement_ {
		my ($self, @new) = @_;
		
		$self->clear_modelElement_;
		$self->add_modelElement_(@new);
	      }
	      sub add_modelElement_ {
		my ($self, @new) = @_;
		
		my $x = $self->{'modelElement_'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::TemplateArgument')
    ->__typecheck($new, 'modelElement_');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ca3d4 name = modelElement, type = Foundation::Core::ModelElement, multiplicity = 1

	  $old->set_modelElement($self) if $old;
	  $new->set_modelElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_modelElement_ {
		my ($self, @new) = @_;

		my $x = $self->{'modelElement_'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::TemplateArgument')
    ->__typecheck($old, 'modelElement_');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ca3d4 name = modelElement, type = Foundation::Core::ModelElement, multiplicity = 1

	  $old->set_modelElement($self) if $old;
	  $new->set_modelElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_modelElement_ {
		my ($self) = @_;

		my $x = $self->{'modelElement_'} ||= [ ];
		my $new; # Place holder

		$self->{'modelElement_'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ca3d4 name = modelElement, type = Foundation::Core::ModelElement, multiplicity = 1

	  $old->set_modelElement($self) if $old;
	  $new->set_modelElement($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86bb704 name = presentation, type = Foundation::Core::PresentationElement multiplicity = *

	      sub presentation {
		my ($self) = @_;
		
		my $x = $self->{'presentation'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_presentation {
		my ($self, @new) = @_;
		
		$self->clear_presentation;
		$self->add_presentation(@new);
	      }
	      sub add_presentation {
		my ($self, @new) = @_;
		
		my $x = $self->{'presentation'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::PresentationElement')
    ->__typecheck($new, 'presentation');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ca5a8 name = subject, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_subject($self) if $old;
	  $new->add_subject($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_presentation {
		my ($self, @new) = @_;

		my $x = $self->{'presentation'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::PresentationElement')
    ->__typecheck($old, 'presentation');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ca5a8 name = subject, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_subject($self) if $old;
	  $new->add_subject($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_presentation {
		my ($self) = @_;

		my $x = $self->{'presentation'} ||= [ ];
		my $new; # Place holder

		$self->{'presentation'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ca5a8 name = subject, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_subject($self) if $old;
	  $new->add_subject($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x86bb98c name = annotatedElement_, type = Foundation::Core::Comment multiplicity = *

	      sub annotatedElement_ {
		my ($self) = @_;
		
		my $x = $self->{'annotatedElement_'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_annotatedElement_ {
		my ($self, @new) = @_;
		
		$self->clear_annotatedElement_;
		$self->add_annotatedElement_(@new);
	      }
	      sub add_annotatedElement_ {
		my ($self, @new) = @_;
		
		my $x = $self->{'annotatedElement_'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Comment')
    ->__typecheck($new, 'annotatedElement_');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x86ca698 name = annotatedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_annotatedElement($self) if $old;
	  $new->add_annotatedElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_annotatedElement_ {
		my ($self, @new) = @_;

		my $x = $self->{'annotatedElement_'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Comment')
    ->__typecheck($old, 'annotatedElement_');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x86ca698 name = annotatedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_annotatedElement($self) if $old;
	  $new->add_annotatedElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_annotatedElement_ {
		my ($self) = @_;

		my $x = $self->{'annotatedElement_'} ||= [ ];
		my $new; # Place holder

		$self->{'annotatedElement_'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x86ca698 name = annotatedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_annotatedElement($self) if $old;
	  $new->add_annotatedElement($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x872d1b0 name = taggedValue, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = 1

	      sub taggedValue {
		my ($self) = @_;
		
		$self->{'taggedValue'};
	      }
	      sub set_taggedValue {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'taggedValue'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue')
    ->__typecheck($new, 'taggedValue');
  ;
		  $self->{'taggedValue'} = $new;        # Recursion lock
		  # AssociationEnd 0x872bc34 name = taggedValue_, type = Foundation::Core::ModelElement, multiplicity = 1

	  $old->set_taggedValue_($self) if $old;
	  $new->set_taggedValue_($self) if $new;
	;
		}

		$self;
	      }
	    
# AssociationEnd 0x8703d38 name = referenceTag, type = Foundation::Extension_Mechanisms::TaggedValue multiplicity = *

	      sub referenceTag {
		my ($self) = @_;
		
		my $x = $self->{'referenceTag'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_referenceTag {
		my ($self, @new) = @_;
		
		$self->clear_referenceTag;
		$self->add_referenceTag(@new);
	      }
	      sub add_referenceTag {
		my ($self, @new) = @_;
		
		my $x = $self->{'referenceTag'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue')
    ->__typecheck($new, 'referenceTag');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x872bcf4 name = referenceValue, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_referenceValue($self) if $old;
	  $new->add_referenceValue($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_referenceTag {
		my ($self, @new) = @_;

		my $x = $self->{'referenceTag'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Extension_Mechanisms::TaggedValue')
    ->__typecheck($old, 'referenceTag');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x872bcf4 name = referenceValue, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_referenceValue($self) if $old;
	  $new->add_referenceValue($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_referenceTag {
		my ($self) = @_;

		my $x = $self->{'referenceTag'} ||= [ ];
		my $new; # Place holder

		$self->{'referenceTag'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x872bcf4 name = referenceValue, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_referenceValue($self) if $old;
	  $new->add_referenceValue($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# AssociationEnd 0x8703ea0 name = importedElement_, type = Foundation::Model_Management::Package multiplicity = *

	      sub importedElement_ {
		my ($self) = @_;
		
		my $x = $self->{'importedElement_'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_importedElement_ {
		my ($self, @new) = @_;
		
		$self->clear_importedElement_;
		$self->add_importedElement_(@new);
	      }
	      sub add_importedElement_ {
		my ($self, @new) = @_;
		
		my $x = $self->{'importedElement_'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Model_Management::Package')
    ->__typecheck($new, 'importedElement_');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x872bd84 name = importedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_importedElement($self) if $old;
	  $new->add_importedElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_importedElement_ {
		my ($self, @new) = @_;

		my $x = $self->{'importedElement_'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Model_Management::Package')
    ->__typecheck($old, 'importedElement_');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x872bd84 name = importedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_importedElement($self) if $old;
	  $new->add_importedElement($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_importedElement_ {
		my ($self) = @_;

		my $x = $self->{'importedElement_'} ||= [ ];
		my $new; # Place holder

		$self->{'importedElement_'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x872bd84 name = importedElement, type = Foundation::Core::ModelElement, multiplicity = *

	  $old->remove_importedElement($self) if $old;
	  $new->add_importedElement($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    
# Attribute 0x869a6c0 name = name, type = Foundation::Data_Types::Name, multiplicity = 1

	  sub name {
	    my ($self) = @_;

	    $self->{'name'};
	  }
	  sub set_name {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Name')
    ->__typecheck($new, 'name');
  ;

	    $self->{'name'} = $new;

	    $self;
	  }
	
# Attribute 0x874f72c name = visibility, type = Foundation::Data_Types::VisibilityKind, multiplicity = 1

	  sub visibility {
	    my ($self) = @_;

	    $self->{'visibility'};
	  }
	  sub set_visibility {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::VisibilityKind')
    ->__typecheck($new, 'visibility');
  ;

	    $self->{'visibility'} = $new;

	    $self;
	  }
	
# Attribute 0x868e130 name = isSpecification, type = Foundation::Data_Types::Boolean, multiplicity = 1

	  sub isSpecification {
	    my ($self) = @_;

	    $self->{'isSpecification'};
	  }
	  sub set_isSpecification {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Boolean')
    ->__typecheck($new, 'isSpecification');
  ;

	    $self->{'isSpecification'} = $new;

	    $self;
	  }
	


1;

