package UML::MetaModel::Foundation::Core::Node;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Classifier);

sub __model_name { 'Foundation::Core::Node' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaNode { 1 }

sub isaFoundation__Core__Node { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::Node')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::Node': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize;

# AssociationEnd 0x8737aec name = deployedComponent, type = Foundation::Core::Component multiplicity = *
$self->{'deployedComponent'} = undef unless exists $self->{'deployedComponent'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Classifier::__initialize_associations;

# AssociationEnd 0x8737aec name = deployedComponent, type = Foundation::Core::Component multiplicity = *

	      if ( defined $self->{'deployedComponent'} && @{$self->{'deployedComponent'}}) {
		my $x = $self->{'deployedComponent'};
		$self->{'deployedComponent'} = [ ];
		$self->add_deployedComponent(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x8737aec name = deployedComponent, type = Foundation::Core::Component multiplicity = *

	      sub deployedComponent {
		my ($self) = @_;
		
		my $x = $self->{'deployedComponent'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_deployedComponent {
		my ($self, @new) = @_;
		
		$self->clear_deployedComponent;
		$self->add_deployedComponent(@new);
	      }
	      sub add_deployedComponent {
		my ($self, @new) = @_;
		
		my $x = $self->{'deployedComponent'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Component')
    ->__typecheck($new, 'deployedComponent');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x875a6b8 name = deploymentLocation, type = Foundation::Core::Node, multiplicity = *

	  $old->remove_deploymentLocation($self) if $old;
	  $new->add_deploymentLocation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_deployedComponent {
		my ($self, @new) = @_;

		my $x = $self->{'deployedComponent'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Core::Component')
    ->__typecheck($old, 'deployedComponent');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x875a6b8 name = deploymentLocation, type = Foundation::Core::Node, multiplicity = *

	  $old->remove_deploymentLocation($self) if $old;
	  $new->add_deploymentLocation($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_deployedComponent {
		my ($self) = @_;

		my $x = $self->{'deployedComponent'} ||= [ ];
		my $new; # Place holder

		$self->{'deployedComponent'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x875a6b8 name = deploymentLocation, type = Foundation::Core::Node, multiplicity = *

	  $old->remove_deploymentLocation($self) if $old;
	  $new->add_deploymentLocation($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

