package UML::MetaModel::Foundation::Core::StructuralFeature;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::Foundation::Core::Feature);

sub __model_name { 'Foundation::Core::StructuralFeature' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaStructuralFeature { 1 }

sub isaFoundation__Core__StructuralFeature { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Core::StructuralFeature')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Core::StructuralFeature': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Feature::__initialize;

# AssociationEnd 0x875adc4 name = type, type = Foundation::Core::Classifier multiplicity = 1
$self->{'type'} = undef unless exists $self->{'type'};
# Attribute 0x8752618 name = multiplicity, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  if ( exists $self->{'multiplicity'} ) {
	    my $x = $self->{'multiplicity'};
	    $self->{'multiplicity'} = undef;
	    $self->set_multiplicity($x);
	  } else {
	    ;
	  }
	
# Attribute 0x87526fc name = changeability, type = Foundation::Data_Types::ChangeableKind, multiplicity = 1

	  if ( exists $self->{'changeability'} ) {
	    my $x = $self->{'changeability'};
	    $self->{'changeability'} = undef;
	    $self->set_changeability($x);
	  } else {
	    ;
	  }
	
# Attribute 0x86fa94c name = targetScope, type = Foundation::Data_Types::ScopeKind, multiplicity = 1

	  if ( exists $self->{'targetScope'} ) {
	    my $x = $self->{'targetScope'};
	    $self->{'targetScope'} = undef;
	    $self->set_targetScope($x);
	  } else {
	    ;
	  }
	
# Attribute 0x86faa48 name = ordering, type = Foundation::Data_Types::OrderingKind, multiplicity = 1

	  if ( exists $self->{'ordering'} ) {
	    my $x = $self->{'ordering'};
	    $self->{'ordering'} = undef;
	    $self->set_ordering($x);
	  } else {
	    ;
	  }
	

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::Foundation::Core::Feature::__initialize_associations;

# AssociationEnd 0x875adc4 name = type, type = Foundation::Core::Classifier multiplicity = 1

	      if ( defined $self->{'type'} ) {
		my $x = $self->{'type'};
		$self->{'type'} = undef;
		$self->set_type($x);
	      }
	    

  $self;
}

# AssociationEnd 0x875adc4 name = type, type = Foundation::Core::Classifier multiplicity = 1

	      sub type {
		my ($self) = @_;
		
		$self->{'type'};
	      }
	      sub set_type {
		my ($self, $new) = @_;

		no warnings;

		my $old;
		if ( ($old = $self->{'type'}) ne $new ) { # Recursion lock
		  ! defined($new) || 
    $self->__autouse('UML::MetaModel::Foundation::Core::Classifier')
    ->__typecheck($new, 'type');
  ;
		  $self->{'type'} = $new;        # Recursion lock
		  # AssociationEnd 0x86ba824 name = typedFeature, type = Foundation::Core::StructuralFeature, multiplicity = *

	  $old->remove_typedFeature($self) if $old;
	  $new->add_typedFeature($self) if $new;
	;
		}

		$self;
	      }
	    
# Attribute 0x8752618 name = multiplicity, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  sub multiplicity {
	    my ($self) = @_;

	    $self->{'multiplicity'};
	  }
	  sub set_multiplicity {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::Multiplicity')
    ->__typecheck($new, 'multiplicity');
  ;

	    $self->{'multiplicity'} = $new;

	    $self;
	  }
	
# Attribute 0x87526fc name = changeability, type = Foundation::Data_Types::ChangeableKind, multiplicity = 1

	  sub changeability {
	    my ($self) = @_;

	    $self->{'changeability'};
	  }
	  sub set_changeability {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ChangeableKind')
    ->__typecheck($new, 'changeability');
  ;

	    $self->{'changeability'} = $new;

	    $self;
	  }
	
# Attribute 0x86fa94c name = targetScope, type = Foundation::Data_Types::ScopeKind, multiplicity = 1

	  sub targetScope {
	    my ($self) = @_;

	    $self->{'targetScope'};
	  }
	  sub set_targetScope {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::ScopeKind')
    ->__typecheck($new, 'targetScope');
  ;

	    $self->{'targetScope'} = $new;

	    $self;
	  }
	
# Attribute 0x86faa48 name = ordering, type = Foundation::Data_Types::OrderingKind, multiplicity = 1

	  sub ordering {
	    my ($self) = @_;

	    $self->{'ordering'};
	  }
	  sub set_ordering {
	    my ($self, $new) = @_;

	    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::OrderingKind')
    ->__typecheck($new, 'ordering');
  ;

	    $self->{'ordering'} = $new;

	    $self;
	  }
	


1;

