package UML::MetaModel::Foundation::Data_Types::Boolean;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::__ObjectBase Exporter);

our @EXPORT_OK = qw(FALSE TRUE);

sub __model_name { 'Foundation::Data_Types::Boolean' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaBoolean { 1 }

sub isaFoundation__Data_Types__Boolean { 1 }

my %__literal = ('false' => 'false', 'true' => 'true');

sub __validate
{
  my ($self, $x) = @_;
   $__literal{$x} ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Data_Types::Boolean': value '$x'")  unless __validate($self, $x);
  $x;
}

sub new
{
  my ($self, @args) = @_;
  my $x = pop(@args);
  $x = (defined($x) && 
			   $x ne '' && 
			   $x ne '0' && 
			   $x ne 'false' && 
			   $x ne 'no'
			   )
			;
  __typecheck($self, $x);
  $x;
}



1;

