package UML::MetaModel::Foundation::Data_Types::CallConcurrencyKind;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::__ObjectBase Exporter);

our @EXPORT_OK = qw(SEQUENTIAL GUARDED CONCURRENT);

sub __model_name { 'Foundation::Data_Types::CallConcurrencyKind' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaCallConcurrencyKind { 1 }

sub isaFoundation__Data_Types__CallConcurrencyKind { 1 }

my %__literal = ('sequential' => 'sequential', 'guarded' => 'guarded', 'concurrent' => 'concurrent');

sub __validate
{
  my ($self, $x) = @_;
   $__literal{$x} ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Data_Types::CallConcurrencyKind': value '$x'")  unless __validate($self, $x);
  $x;
}

sub new
{
  my ($self, @args) = @_;
  my $x = pop(@args);
  die("Invalid EnumerationLiteral") unless $__literal{$x};
  $x;
}

# EnumerationLiteral 
sub SEQUENTIAL { 'sequential' }

# EnumerationLiteral 
sub GUARDED { 'guarded' }

# EnumerationLiteral 
sub CONCURRENT { 'concurrent' }



1;

