package UML::MetaModel::Foundation::Data_Types::Multiplicity;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::__ObjectBase);

sub __model_name { 'Foundation::Data_Types::Multiplicity' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaMultiplicity { 1 }

sub isaFoundation__Data_Types__Multiplicity { 1 }

sub __validate
{
  my ($self, $x) = @_;
  
      # Use $x->isa$Class???
      UNIVERSAL::isa($x, 'UML::MetaModel::Foundation::Data_Types::Multiplicity')
    ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Data_Types::Multiplicity': value '$x'")  unless __validate($self, $x);
  $x;
}

sub __initialize
{
  my ($self) = @_;

  $self->UML::MetaModel::__ObjectBase::__initialize;

# AssociationEnd 0x8683b4c name = range, type = Foundation::Data_Types::MultiplicityRange multiplicity = 1..*
$self->{'range'} = undef unless exists $self->{'range'};

  $self;
}

sub __initialize_associations
{
  my ($self) = @_;

  $self->UML::MetaModel::__ObjectBase::__initialize_associations;

# AssociationEnd 0x8683b4c name = range, type = Foundation::Data_Types::MultiplicityRange multiplicity = 1..*

	      if ( defined $self->{'range'} && @{$self->{'range'}}) {
		my $x = $self->{'range'};
		$self->{'range'} = [ ];
		$self->add_range(@$x);
	      }
	    

  $self;
}

# AssociationEnd 0x8683b4c name = range, type = Foundation::Data_Types::MultiplicityRange multiplicity = 1..*

	      sub range {
		my ($self) = @_;
		
		my $x = $self->{'range'} ||= [ ];
		wantarray ? @{$x} : $x;
	      }
	      sub set_range {
		my ($self, @new) = @_;
		
		$self->clear_range;
		$self->add_range(@new);
	      }
	      sub add_range {
		my ($self, @new) = @_;
		
		my $x = $self->{'range'} ||= [ ];
		my $old; # Place holder

		for my $new ( @new ) {
		  unless ( grep($_ eq $new, @$x) ) { # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::MultiplicityRange')
    ->__typecheck($new, 'range');
  ;
		    push(@{$x}, $new);                # Recursion lock
		    # AssociationEnd 0x8737b94 name = range_, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  $old->set_range_($self) if $old;
	  $new->set_range_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub remove_range {
		my ($self, @new) = @_;

		my $x = $self->{'range'} ||= [ ];
		my $new; # Place holder

		for my $old ( @new ) {
		  if ( grep($_ eq $old, @$x) ) {   # Recursion lock
		    
    $self->__autouse('UML::MetaModel::Foundation::Data_Types::MultiplicityRange')
    ->__typecheck($old, 'range');
  ;
		    @$x = grep($_ ne $old, @$x); # Recursion lock
		    # AssociationEnd 0x8737b94 name = range_, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  $old->set_range_($self) if $old;
	  $new->set_range_($self) if $new;
	;
		  }
		}
		
		$self;
	      }
	      sub clear_range {
		my ($self) = @_;

		my $x = $self->{'range'} ||= [ ];
		my $new; # Place holder

		$self->{'range'} = [ ];              # Recursion lock
		for my $old ( @$x ) { # Recursion lock
		  # AssociationEnd 0x8737b94 name = range_, type = Foundation::Data_Types::Multiplicity, multiplicity = 1

	  $old->set_range_($self) if $old;
	  $new->set_range_($self) if $new;
	;
		}
		
		$self;
	      }
	      
	    


1;

