package UML::MetaModel::Foundation::Data_Types::Name;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::__ObjectBase);

sub __model_name { 'Foundation::Data_Types::Name' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaName { 1 }

sub isaFoundation__Data_Types__Name { 1 }

sub __validate
{
  my ($self, $x) = @_;
  $x =~ /^[a-z_][a-z_0-9]*$/i;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Data_Types::Name': value '$x'")  unless __validate($self, $x);
  $x;
}

sub new
{
  my ($self, @args) = @_;
  my $x = pop(@args);
  __typecheck($self, $x);
  $x;
}



1;

