package UML::MetaModel::Foundation::Data_Types::PseudostateKind;

#################################################################

our $VERSION = do { my @r = (q$Revision: 1.5 $ =~ /\d+/g); sprintf "%d." . "%03d" x $#r, @r };

use strict;
use warnings;

use base qw(UML::MetaModel::__ObjectBase Exporter);

our @EXPORT_OK = qw(CHOICE DEEPHISTORY FORK INITIAL JOIN JUNCTION SHALLOWHISTORY);

sub __model_name { 'Foundation::Data_Types::PseudostateKind' }


  my $__class;
  sub __class 
{ 
  my ($self) = @_;
  
  unless ( $__class ) {
    use UML::MetaMetaModel::Util qw(Namespace_ownedElement_name_);
    $__class = Namespace_ownedElement_name_($self->__metamodel, $self->__model_name);
  }
  
  $__class;
}
sub isaPseudostateKind { 1 }

sub isaFoundation__Data_Types__PseudostateKind { 1 }

my %__literal = ('choice' => 'choice', 'deepHistory' => 'deepHistory', 'fork' => 'fork', 'initial' => 'initial', 'join' => 'join', 'junction' => 'junction', 'shallowHistory' => 'shallowHistory');

sub __validate
{
  my ($self, $x) = @_;
   $__literal{$x} ;
}

sub __typecheck
{
  my ($self, $x, $msg) = @_;
  die("typecheck: $msg: type 'UML::MetaModel::Foundation::Data_Types::PseudostateKind': value '$x'")  unless __validate($self, $x);
  $x;
}

sub new
{
  my ($self, @args) = @_;
  my $x = pop(@args);
  die("Invalid EnumerationLiteral") unless $__literal{$x};
  $x;
}

# EnumerationLiteral 
sub CHOICE { 'choice' }

# EnumerationLiteral 
sub DEEPHISTORY { 'deepHistory' }

# EnumerationLiteral 
sub FORK { 'fork' }

# EnumerationLiteral 
sub INITIAL { 'initial' }

# EnumerationLiteral 
sub JOIN { 'join' }

# EnumerationLiteral 
sub JUNCTION { 'junction' }

# EnumerationLiteral 
sub SHALLOWHISTORY { 'shallowHistory' }



1;

