#!/usr/local/bin/perl

use 5.6.1;
use strict;
use warnings;

BEGIN {
    use lib "../lib/perl";
    use lib "gen";
};

use IO::Handle;
use IO::Pipe;

use UML::MetaModel;
#use UML::MetaMetaModel;
use UML::Export::XMI;

$DB::single = 1;

my $model = UML::MetaModel->model;

$DB::single = 1;

my $exporter = UML::Export::XMI->new('output' => *STDOUT);

$DB::single = 1;

$exporter->export_Model($model);

#$DB::single = 1;

1;
